' Demonstrates how to read resources from DLLs
' BMPDLL.DLL contains 2 resources: BITMAP_D and BITMAP_B, both bitmaps

DECLARE FUNCTION LoadLibrary LIB "KERNEL32" ALIAS "LoadLibraryA" _
                 (LibFileName AS STRING) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32" ALIAS "FreeLibrary" _
                 (hInst AS LONG) AS LONG
DECLARE FUNCTION LoadBitmap LIB "USER32" ALIAS "LoadBitmapA" _
                 (hInst AS LONG, BitmapName AS STRING) AS LONG


hInst = LoadLibrary("BMPDLL.DLL")
BHandle = LoadBitmap(hInst, "BITMAP_D")
FreeLibrary(hInst)

CREATE Form AS QFORM
    Caption = "Reading resources from DLL"
    CREATE Image AS QIMAGE
        Handle = BHandle
    END CREATE
    ShowModal
END CREATE
