


declare sub formOnResize (Sender as QFORM)
DECLARE SUB dumpSelectedFile (Sender AS QBUTTON)
DECLARE SUB saveListAsFile (Sender AS QBUTTON)
DECLARE SUB clearList (Sender AS QBUTTON)
declare sub copyToClipboard (Sender as QBUTTON)
declare sub setSource (Sender as QBUTTON)
declare sub setDestination (Sender as QBUTTON)
declare sub sightHealthSpeed (Sender as QBUTTON)
declare sub changeDirectory (Sender as QDirTree)
declare sub selectFile (Sender as QFileListBox)
declare sub listBox1onChange (Sender as QListBox)
declare sub colorOrCompression (Sender as QBUTTON)
declare sub hexDump
declare sub terrain
declare sub mapObject
declare sub blocked
declare sub mapInfo (s as string)
declare sub missionInfo (s as string)
declare sub editFile
declare function firstPart(gw$) as string
declare function lastPart(gw$) as string
declare function locationAt(x as word, y as word, f$) as byte
declare sub copySpecial
declare sub copyLocation(l as word)
declare sub docMission (Sender as QBUTTON)
declare sub searchListbox (Sender as QBUTTON)
declare sub colFile (f$ as string)
declare sub pckFile (f$ as string)
declare sub pckImage (f$ as string, startOfImage as long, endOfImage as long)
declare sub loadFile (f$ as string)
declare sub drawImage (f$ as string, startOfImage as long, endOfImage as long, xp as word, yp as word, s as word)
declare sub drawMyImage (f$ as string, startOfImage as long, endOfImage as long, xp as word, yp as word, s as word)
declare sub saveColValue
declare sub saveColFile
declare sub drawSmallImage
declare sub onMyTimer
declare sub imediateChanged (Sender as Qcheckbox)

declare sub getSupport (mPath as string)
declare sub getMapUnits (mPath as string)
declare sub getBriefing (mPath as string)
declare sub getGroups (mPath as string)
declare sub getPhrases (mPath as string)
declare sub getPlayers (mPath as string)
declare sub getScripts (mPath as string)
declare sub explain
declare sub colChange
declare sub vuChange
declare sub drawPalette
declare sub saveMassChanges
declare sub grayScaleChanges
declare sub findSimilarShades
declare sub findSimilarColors
declare sub clickedPalette (b%, x%, y%, s%)
declare sub clickedImage (b%, x%, y%, s%)
declare sub cvtCol (ssCol as word, r as word, g as word, b as word, bt as word)
declare function winCol (r as word, g as word, b as word, bt as word) as long

declare function groupId(g as integer) as string


$INCLUDE "RAPIDQ.INC"

CREATE Form AS QFORM
    Caption = "SuSt_Stuff 0.0.120"
    Width = 759
    Height = 500
    Center
    OnResize = formOnResize
    CREATE Edit1 AS QEDIT
        Text = ""
        Left = 15
        Top = 3
        Width = 630
        Height = 24
        TabOrder = 1
    END CREATE
    CREATE Edit2 AS QEDIT
        Text = ""
        Left = 15
        Top = 29
        Width = 630
        Height = 24
        TabOrder = 2
    END CREATE
    CREATE Edit3 AS QEDIT
        Text = ""
        Left = 15
        Top = 55
        Width = 630
        Height = 24
        TabOrder = 2
    END CREATE
    CREATE ListBox1 AS QLISTBOX
        Left = 15
        Top = 290
        Width = 500
        Height = 150
        ItemHeight = 16
        TabOrder = 3
        multiselect = true
        onDblClick = listBox1onChange
'        onChange = listBox1onChange
        hint = "this is a hint"
        font.name = "Courier New"
'        font.size = 6
        font.size = 10
    END CREATE
    CREATE Button4 AS QBUTTON
        Caption = "copy selected text to clipboard"
        Left = 15
        Top = 250
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = copyToClipboard
        visible = true
    END CREATE
    CREATE Button2 AS QBUTTON
        Caption = "create text file"
        Left = 225
        Top = 250
        Width = 100
        Height = 24
        TabOrder = 4
        OnClick = saveListAsFile
        visible = true
    END CREATE
    CREATE Button3 AS QBUTTON
        Caption = "clear list"
        Left = 335
        Top = 250
        Width = 70
        Height = 24
        OnClick = clearList
        visible = true
    end create
    CREATE Button1 AS QBUTTON
        Caption = "search for:"
        Left = 415
        Top = 250
        Width = 90
        Height = 24
        TabOrder = 5
        OnClick = searchListbox
        visible = true
    END CREATE
    CREATE Edit4 AS QEDIT
        Text = ""
        Left = 515
        Top = 250
        Width = 100
        Height = 24
    END CREATE
    
' windows pallete conversion factor
    CREATE Edit5 AS QEDIT
        Text = "12"
        Left = 750
        Top = 360
        Width = 30
        Height = 20
'        enabled = false
        color = &Hff0000
        onchange = colChange
    END CREATE
    CREATE Edit6 AS QEDIT
        Text = "6"
        Left = 715
        Top = 360
        Width = 30
        Height = 20
'        enabled = false
        color = &H00ff00
        onchange = colChange
    END CREATE
    CREATE Edit7 AS QEDIT
        Text = "12"
        Left = 680
        Top = 360
        Width = 30
        Height = 20
'        enabled = false
        color = &H0000ff
        onchange = colChange
    END CREATE
' new values
    CREATE Edit8 AS QEDIT
        Text = "8"
        Left = 680
        Top = 390
        Width = 30
        Height = 20
    END CREATE
    CREATE Edit9 AS QEDIT
        Text = "4"
        Left = 715
        Top = 390
        Width = 30
        Height = 20
    END CREATE
    CREATE Edit10 AS QEDIT
        Text = "8"
        Left = 750
        Top = 390
        Width = 30
        Height = 20
    END CREATE

    create sc8 as Qscrollbar
        Left = 680
        Top = 420
        Width = 180
        Height = 15
        kind = 1
        min = 0
        max = 31
        onchange = colChange
    end create
    create sc9 as Qscrollbar
        Left = 715
        Top = 420
        Width = 180
        Height = 15
        kind = 1
        min = 0
        max = 63
        onchange = colChange
    end create
    create sc10 as Qscrollbar
        Left = 750
        Top = 420
        Width = 180
        Height = 15
        kind = 1
        min = 0
        max = 31
        onchange = colChange
    end create
    create pixelSize as Qscrollbar
        Left = 50
        Top = 290
        Width = 100
        Height = 15
        kind = 0
        min = 1
        max = 8
        position = 5
        hint = "change pixel size" 
        onchange = vuChange
    end create
    create lbps as qlabel
        Left = 70
        Top = 310
        Width = 100
        Height = 20
        caption = "1 - size - 8"
        alignment = 2
    end create
    create sc11 as Qscrollbar
        Left = 170
        Top = 290
        Width = 200
        Height = 15
        kind = 0
        min = 0
        max = 31
        hint = "change view angle" 
        onchange = vuChange
    end create
    create lbva as qlabel
        Left = 220
        Top = 310
        Width = 100
        Height = 20
        caption = "1 - view angle - 32"
        alignment = 2
    end create
    create spinImage as qcheckbox
        Left = 400
        Top = 290
        caption = "spin image"
        width = 100
    end create
    create showSelectionAsWhite as qcheckbox
        Left = 400
        Top = 320
        caption = "show palette selection"
        width = 200
    end create
    CREATE Button10 AS QBUTTON
        Caption = "save color value"
        Left = 800
        Top = 390
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = saveColValue
    END CREATE
    create imediateChange as qcheckbox
        Left = 800
        Top = 360
        caption = "save color as it changes"
        width = 200
        onCLick = imediateChanged
    end create
    CREATE Button11 AS QBUTTON
        Caption = "save col file"
        Left = 800
        Top = 560
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = saveColFile
    END CREATE
    CREATE massChange AS QBUTTON
        Caption = "save selected colors"
        Left = 800
        Top = 480
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = saveMassChanges
    END CREATE
    CREATE grayScale AS QBUTTON
        Caption = "create gray scale"
        Left = 800
        Top = 510
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = grayScaleChanges
    END CREATE
    CREATE findSimShadeBtn AS QBUTTON
        Caption = "similar shades"
        Left = 800
        Top = 540
        Width = 95
        Height = 24
        TabOrder = 5
        OnClick = findSimilarShades
    END CREATE
    CREATE findSimColorBtn AS QBUTTON
        Caption = "similar colors"
        Left = 905
        Top = 540
        Width = 95
        Height = 24
        TabOrder = 5
        OnClick = findSimilarColors
    END CREATE
    CREATE Button12 AS QBUTTON
        Caption = "show compression"
        Left = 480
        Top = 345
        Width = 120
        Height = 24
        TabOrder = 5
        OnClick = colorOrCompression
'        visible = false
    END CREATE
            
    CREATE Button5 AS QBUTTON
        Caption = "set source mission for copy"
        Left = 670
        Top = 90
        Height = 24
        Width = 200
        TabOrder = 5
        OnClick = setSource
        visible = false
    END CREATE
    CREATE Button8 AS QBUTTON
        Caption = "set destination mission for copy"
        Left = 670
        Top = 120
        Height = 24
        Width = 200
        TabOrder = 5
        OnClick = setDestination
        visible = false
    END CREATE
    CREATE Button9 AS QBUTTON
        Caption = "document mission"
        Left = 670
        Top = 150
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = docMission
        visible = false
    END CREATE
    CREATE Button6 AS QBUTTON
        Caption = "sight, health, speed"
        Left = 670
        Top = 180
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = sightHealthSpeed
        visible = false
    END CREATE
    CREATE Button7 AS QBUTTON
        Caption = "open file with NOTEPAD"
        Left = 670
        Top = 210
        Width = 200
        Height = 24
        TabOrder = 5
        OnClick = editFile
'        visible = true
        visible = false
    END CREATE
    create dirtree as QDirTree
        initialDir = CURDIR$
'        initialDir = "c:\program files\sudden strike\"        
        Left = 15
        Top = 90
        width = 400
        height = 150
        onChange = changeDirectory
        showhint = false
    end create
    CREATE FileListBox1 AS QFILELISTBOX
        Left = 450
        Top = 90
        width = 200
        Height = 150
        Drive = "C"
'        Directory = "D:\rapidQ"
'        Directory = "C:\rapidQ"
        ItemHeight = 16
        onClick = selectFile
        onDblClick = editFile
    END CREATE

    create myCanvas as Qcanvas
        Left = 400
        Top = 380
        width = 220
        Height = 220
        onPaint = drawSmallImage
'        bmp = "grass.bmp"
    end create
    create colPalette as QIMAGE
        Left = 670
        Top = 20
        width = 320
        Height = 320
        bmphandle = 320bmp
'        bmp = "320.bmp"
        onMouseDown = clickedPalette 
    end create
END CREATE

'create myBitmap as QBITMAP
'    bmp = "blank_200x200.bmp"
'    width = 200
'    Height = 200
'end create

'Insert your initialization code here

dim defSight$
dim defHealth$
dim defMoveSpeed$

dim glbMapType as word
dim glbHeight as word
dim glbWidth as word
dim glbMisHeight as word
dim glbMisWidth as word

dim srcGlbHeight as word
dim srcGlbWidth as word
dim destGlbHeight as word
dim destGlbWidth as word

' for copy map to map
dim srcMapFolder$
dim srcMisFolder$
dim srcLocPtr as word
dim srcLoc(64) as word
dim srcMinX(64) as word
dim srcMaxX(64) as word
dim srcMinY(64) as word
dim srcMaxY(64) as word

dim destMapFolder$
dim destMisFolder$
dim destLocPtr as word
dim destLoc(64) as word
dim destMinX(64) as word
dim destMaxX(64) as word
dim destMinY(64) as word
dim destMaxY(64) as word
' COL file values
dim colValue(1024) as word  
dim glbColPtr as word
dim glbPaletteSelection as integer
dim glbPaletteEndSelection as integer
dim glbDisplayAsWhite as word
dim glbGrayScale as word
dim glbColFileName as string
dim glbColMax as word
dim glbPixelSize as integer
' PCK stuff
dim glbPCKFileName as string
dim pfStart(500) as long
dim pfEnd(500) as long
dim WINcolValue(1024) as long  
dim BMPcolValue(1024) as long  
dim glbTurret as word
dim myTimer as qtimer
dim glbSkipChange as integer
dim tRed as long
dim tGreen as long
dim tBlue as long
dim tColors as long
                

glbHeight = 0
glbWidth = 0
glbMisHeight = 0
glbMisWidth = 0
glbSkipChange = 0
glbPaletteSelection = 500
glbPaletteEndSelection = -1
glbGrayScale = 0

' documentation stuff
dim reinf$(64)
dim phrs$(64)
dim pName$(4) as string
dim pn0$
dim pn1$
dim pn2$
dim pn3$

dim glbWhatInList as string

' copy for limit testing
'    call copySpecial
    
origDir$ = curdir$

        edit5.visible = false
        edit6.visible = false
        edit7.visible = false
        edit8.visible = false
        edit9.visible = false
        edit10.visible = false
        sc8.visible = false
        sc9.visible = false
        sc10.visible = false
        sc11.visible = false
        button10.visible = false
        button11.visible = false
        button12.visible = false
        showSelectionAsWhite.visible = false
        imediateChange.visible = false
        spinImage.visible = false
        myTimer.enabled = false
        findSimShadeBtn.enabled = false
        findSimShadeBtn.visible = false
        findSimColorBtn.enabled = false
        findSimColorBtn.visible = false
        lbva.visible = false
        lbps.visible = false
        spinImage.visible = false
        pixelSize.visible = false
        sc11.visible = false
        grayScale.visible = false
        massChange.visible = false
'        colPalette.visible = false

listbox1.additems ""
listbox1.additems form.caption
listbox1.additems "written in rapid-q basic language at 1024 x 768 resolution."
listbox1.additems ""
listbox1.additems "  this program is a swiss army kife for Sudden Strike Forever.  "
listbox1.additems ""
listbox1.additems "  expand your sudden strike folder and browse around."
listbox1.additems ""
listbox1.additems "  this program started out as a documentation creator for missons "
listbox1.additems "  created using QED.  "
listbox1.additems "  go to your maps.ca folder  and expand it ..."
listbox1.additems ""
listbox1.additems ""
listbox1.additems ""
fd! = 1

fileListBox1.directory = dirTree.directory

form.windowstate = wsMaximized
Form.ShowModal

'--------- Subroutines ---------

SUB dumpSelectedFile (Sender AS QBUTTON)
     if fd! = 1 then listbox1.clear
     fd! = 0
     call hexDump
'     button1.visible = false
'     button2.visible = true
'     button3.visible = true
'     button4.visible = true
end sub

sub hexDump
     listbox1.additems edit2.text
 'for hex display 
     DIM File AS QFileStream
     dim f$
     glbWhatInList = ""
     f$ = edit1.text & edit2.text 
     crlf! = 0
     lf! = 0
     chars! = 0
' determine if text file ...
     File.Open(f$, fmOpenRead)
     i$ = file.readstr(256)
     for a! = 1 to 256
         if mid$(i$,a!,2) = chr$(13) & chr$(10) then crlf! = 3
     next a!
     file.close
     if crlf! > 2 then
         File.Open(f$, fmOpenRead)
         while not file.eof
             i$ = file.readline
             listbox1.additems i$
             form.repaint
         wend
         file.close
         listbox1.additems ""
         listbox1.additems "---------------- hex dump -------------- " 
     end if 
     
     File.Open(f$, fmOpenRead)
     hexSixe! = 2048
     while not file.eof and chars! < hexSixe!
'     while not file.eof 
' hex display 16 at a time ...
        i$ = file.readstr(16)
'        listbox1.additems str$(len(i$)) & ":" & i$
        p$ = ""
        for a! = 1 to 16
            if mid$(i$,a!,1) < " " or mid$(i$,a!,1) > "z" then 
                p$ = p$ & "_"
                h! = h! + 1
            else
                p$ = p$ & mid$(i$,a!,1)
            end if
        ' last char was 0D so check for 0A 
            if mid$(i$,a!,1) = chr$(10) then 
                if cr! = 1 then
                    crlf! = crlf! + 1
                else
                    lf! = lf! + 1
                end if
                
            end if
            if cr! = 1 then cr! = 0
            if mid$(i$,a!,1) = chr$(13) then 
            ' H 0D flag
                cr! = 1
            end if
        next a!
        po$ = str$(chars!)
        po$ = space$(8 - len(po$)) & po$ & " " & right$("0000" & hex$(chars!),4) & " "
        chars! = chars! + 16
'        listbox1.additems po$ & ":" & p$
        p$ = po$ & "|" & p$ & "|"
'        for a! = 1 to len(i$)
        for a! = 1 to 16
            p$ = p$ & " " & right$(hex$(asc(mid$(i$,a!,1))),2)
        next a!
        listbox1.additems p$
     wend
     file.close
     listbox1.additems ""
'     listbox1.additems str$(lf!) & " linefeeds, " & str$(crlf!) & " cr-lfs"
'     listbox1.additems str$(h!) & " hex characters out of " & str$(chars!) & " characters read"
END SUB


SUB saveListAsFile (Sender AS QBUTTON)
' write to text file
     DIM File AS QFileStream
     dim f$
     f$ = "c:\program files\sudden strike\unit_list.txt"
     listbox1.savetofile(f$)
     button2.visible = false
END SUB

SUB clearList (Sender AS QBUTTON)
    listbox1.clear
'    button1.visible = true
'    button2.visible = false
'    button3.visible = false
'    button4.visible = false
end sub


sub formOnResize
    listbox1.height = form.height - 350
    listbox1.width = form.width - 50
end sub

sub copyToClipboard
' write selected text to clipboard ...
dim a!
dim x$
dim last!
dim first!

    x$ = ""
    last! = 1
    first! = 1
    for a! = 0 to listbox1.itemCount - 1
        if listbox1.selected(a!) = 1 then 
            if first! = 0 and last! = 0 then x$ = x$ & chr$(13) & chr$(10) & "     ...     " & chr$(13) & chr$(10) & chr$(13) & chr$(10)
            x$ = x$ & listbox1.item(a!) & chr$(13) & chr$(10)
            first! = 0
        end if
        last! = listbox1.selected(a!)
    next a!
'    edit3.text = x$
    clipboard.open
    clipboard.setastext(x$)
    clipboard.close
end sub

sub copySpecial
    DIM src AS QFileStream
    DIM dest AS QFileStream
    dim w1 as word
    dim w2 as word
    dim w3 as word
    dim w4 as word
    dim wx as word
    dim wy as word
' duplicate objects for limit work
    fsrc$ = "C:\Program Files\Sudden Strike\maps.ca\map.020\objects"
    fdest$ = "C:\Program Files\Sudden Strike\maps.ca\map.020\objects.new"
    listbox1.additems "source: " & fsrc$
    listbox1.additems "destination: " & fdest$
    src.Open(fsrc$, fmOpenRead)
    dest.Open(fdest$, fmCreate)
    while not src.eof 
' read 4 words at a time ...
        src.read(w1)
        src.read(w2)
        src.read(w3)
        src.read(w4)
' original objects
        dest.write(w1)
        dest.write(w2)
        dest.write(w3)
        dest.write(w4)
        
        wx = (((w1 / 32) + 36) * 32) + (w1 and 31)
'        wy = ((w2 / 32) * 32) + (w2 and 31)
        wy = w2
        dest.write(wx)
        dest.write(wy)
        dest.write(w3)
        dest.write(w4)
        
        wx = (((w1 / 32) + 72) * 32) + (w1 and 31)
'        wy = ((w2 / 32) * 32) + (w2 and 31)
        wy = w2
        dest.write(wx)
        dest.write(wy)
        dest.write(w3)
        dest.write(w4)
        
        wx = (((w1 / 32) + 108) * 32) + (w1 and 31)
'        wy = ((w2 / 32) * 32) + (w2 and 31)
        wy = w2
        dest.write(wx)
        dest.write(wy)
        dest.write(w3)
        dest.write(w4)
        
    wend
    src.close
    dest.close
end sub

sub copyLocation(l as word)
' l points to array location, not SuSt location number ...
    dim srcXStart as word
    dim srcXLimit as word
    dim srcYStart as word
    dim srcYLimit as word
    dim diffX as word
    dim diffY as word
    dim destXStart as word
    dim destYStart as word
    DIM src AS QFileStream
    DIM dest AS QFileStream
    dim w1 as word
    dim w2 as word
    dim w3 as word
    dim w4 as word
    dim wx as word
    dim wy as word
    dim dwx as word
    dim dwy as word
    DIM srcLocF AS QFileStream
    DIM destLocF AS QFileStream
    dim srcL as byte
    dim destL as byte
    dim a as word
    dim b as word

    srcXStart = srcMinX(l)
    srcXLimit = srcMaxX(l) - srcMinX(l)
    srcYStart = srcMinY(l)
    srcYLimit = srcMaxY(l) - srcMinY(l)
    destXStart = destMinX(l)
    destYStart = destMinY(l)
    diffX = destMinX(l) - srcMinX(l)
    diffY = destMinY(l) - srcMinY(l)
' terrain
    fsrc$ = srcMapFolder$ & "rhombs"
    fdest$ = destMapFolder$ & "rhombs"
    listbox1.additems "source: " & fsrc$
    listbox1.additems "destination: " & fdest$
    src.Open(fsrc$, fmOpenRead)
    dest.Open(fdest$, fmOpenReadWrite)

    srcLocF.Open(srcMisFolder$ & "locations", fmOpenRead)
    destLocF.Open(destMisFolder$ & "locations", fmOpenReadWrite)
    
    listbox1.additems srcMisFolder$
    listbox1.additems destMisFolder$
    form.repaint
    for a = 0 to srcYLimit
        for b = 0 to srcXLimit
        ' check for location 'l' in source and destination ...
            srcLocF.position = ((srcXStart + b) + ((srcYstart + a) * 512))
            srcLocF.read(srcL)
            destLocF.position = ((destXStart + b) + ((destYstart + a) * 512))
            destLocF.read(destL)
            if srcL = srcLoc(l) then
                if destL = destLoc(l) then
                    ' calculate terrain position in source file
                    src.position = ((srcXStart + b) + ((srcYstart + a) * srcGlbWidth)) * 4
'            listbox1.additems "src " & str$(srcXStart + b!) & " " & str$(srcYstart + a!) & " " & str$(((srcXStart + b!) + ((srcYstart + a!) * srcGlbWidth)) * 4)
                    r$ = src.readBinstr(4)
                    ' calculate terrain position in destination file
                    dest.position = ((destXStart + b) + ((destYstart + a) * destGlbWidth)) * 4
'            listbox1.additems "dest " & str$(destXStart + b!) & " " & str$(destYstart + a!) & " " & str$(((destXStart + b!) + ((destYstart + a!) * destGlbWidth)) * 4)
                    dest.writeBinStr(r$,4)

                end if
            end if        
        next b
    next a
    src.close
    dest.close
' blocked, visibility, waves
    fsrc$ = srcMapFolder$ & "cflags"
    fdest$ = destMapFolder$ & "cflags"
    listbox1.additems "source: " & fsrc$
    listbox1.additems "destination: " & fdest$
    src.Open(fsrc$, fmOpenRead)
    dest.Open(fdest$, fmOpenReadWrite)
    for a = 0 to srcYLimit
        for b = 0 to srcXLimit
            srcLocF.position = ((srcXStart + b) + ((srcYstart + a) * 512))
            srcLocF.read(srcL)
            destLocF.position = ((destXStart + b) + ((destYstart + a) * 512))
            destLocF.read(destL)
'            if srcL = l then
'                if destL = l then
            if srcL = srcLoc(l) then
                if destL = destLoc(l) then
                    src.position = ((srcXStart + b) + ((srcYstart + a) * srcGlbWidth)) * 2
                    r$ = src.readBinstr(2)
                    dest.position = ((destXStart + b) + ((destYstart + a) * destGlbWidth)) * 2
                    dest.writeBinStr(r$,2)
                end if
            end if
        next b
    next a
    src.close
    dest.close
' objects
    fsrc$ = srcMapFolder$ & "objects"
    fdest$ = destMapFolder$ & "objects"
    listbox1.additems "source: " & fsrc$
    listbox1.additems "destination: " & fdest$
    src.Open(fsrc$, fmOpenRead)
    dest.Open(fdest$, fmOpenReadWrite)
    dest.position = dest.size
    while not src.eof 
' read 4 words at a time ...
        src.read(w1)
        src.read(w2)
        src.read(w3)
        src.read(w4)
        wx = w1 / 32
        wy = w2 / 32

        srcLocF.position = (wx + (wy * 512))
        srcLocF.read(srcL)
        dwx = (wx + diffX)
        dwy = (wy + diffY)
        destLocF.position = (dwx + (dwy * 512))
        destLocF.read(destL)

        if srcL = srcLoc(l) then
            if destL = destLoc(l) then
            ' need this one
                 wx = ((wx + diffX) * 32) + (w1 and 31)
                 wy = ((wy + diffY) * 32) + (w2 and 31)
                 dest.write(wx)
                 dest.write(wy)
                 dest.write(w3)
                 dest.write(w4)
            end if
        end if

    wend
    src.close
    dest.close
    srcLocF.close
    destLocF.close
end sub

function locationAt (x as word, y as word, f$) as byte
DIM File AS QFileStream
dim b as byte
    l = 0 
    f1$ = f$ & "locations"
    listbox1.additems " loc " & f1$
    form.repaint
    File.Open(f1$, fmOpenRead)
    file.position = (x + (y * 512))
    file.read(b)
    file.close
    listbox1.additems " loc x " & str$(x) & " y " & str$(y) & " loc " str$(b)
    locationAt = b
end function

SUB setSource (Sender AS QBUTTON)
    DIM File AS QFileStream
    dim f$
    dim l as byte
    dim a as integer
    dim b as integer
    dim f as integer
    dim p as integer
    for a = 0 to 63
        srcLoc(a) = 0
        srcMinX(a) = 999
        srcMaxX(a) = 0
        srcMinY(a) = 999
        srcMaxY(a) = 0
    next a
    srcLocPtr = 0

   '-- Enter your code here
    if left$(right$(edit1.text,9),5) = "\MIS." then
         srcMapFolder$ = left$(edit1.text, len(edit1.text) - 8)
         srcMisFolder$ = edit1.text
         listbox1.additems "source map: " & srcMapFolder$ 
         listbox1.additems "   mission: " & srcMisFolder$
         listbox1.additems ""
         call missionInfo (edit1.text & "info")
         srcGlbHeight = glbMisHeight
         srcGlbWidth = glbMisWidth
         f$ = edit1.text & "locations" 
         listbox1.additems f$
         File.Open(f$, fmOpenRead)
'         for a! = 0 to (glbMisWidth - 1)
'             for b! = 0 to (glbMisHeight - 1)
         for a = 0 to 511
             for b = 0 to 511
                 file.read(l)
                 if l <> 0 then
                     if l = srcLoc(l) then
                         if b < srcMinX(l) then srcMinX(l) = b
                         if b > srcMaxX(l) then srcMaxX(l) = b
                         if a < srcMinY(l) then srcMinY(l) = a
                         if a > srcMaxY(l) then srcMaxY(l) = a
                     else
                         srcLoc(l) = l
                         srcMinX(l) = b
                         srcMaxX(l) = b
                         srcMinY(l) = a
                         srcMaxY(l) = a
                         srcLocPtr = srcLocPtr + 1
                     end if
                 end if
             next b
         next a
         file.close
         
         for a = 1 to 63
             if srcloc(a) <> 0 then listbox1.additems "loc: " & right$("     " & str$(srcLoc(a)),3) & "     minH" & right$("     " & str$(srcMinX(a)),5) & "     maxH" & right$("     " & str$(srcMaxX(a)),5) & "     minW" & right$("     " & str$(srcMinY(a)),5) & "     maxW" & right$("     " & str$(srcMaxY(a)),5)
             form.repaint            
         next a
         listbox1.additems ""
     else
         listbox1.additems ""
         listbox1.additems " you must be positioned on a mission folder "
         listbox1.additems ""
     end if

END SUB

SUB setDestination (Sender AS QBUTTON)
    DIM File AS QFileStream
    dim l as byte
    dim a as integer
    dim b as integer
    dim f as integer
    dim p as integer
    for a = 0 to 63
        destLoc(a) = 0
        destMinX(a) = 999
        destMaxX(a) = 0
        destMinY(a) = 999
        destMaxY(a) = 0
    next a
    destLocPtr = 0
   '-- Enter your code here
     if left$(right$(edit1.text,9),5) = "\MIS." then
         destMapFolder$ = left$(edit1.text, len(edit1.text) - 8)
         destMisFolder$ = edit1.text
         listbox1.additems "dest.  map: " & destMapFolder$ 
         listbox1.additems "   mission: " & destMisFolder$
         listbox1.additems ""
         call missionInfo (edit1.text & "info")
         destGlbHeight = glbMisHeight
         destGlbWidth = glbMisWidth
         f$ = edit1.text & "locations" 
         listbox1.additems f$
         File.Open(f$, fmOpenRead)
'         for a! = 0 to (glbMisWidth - 1)
'             for b! = 0 to (glbMisHeight - 1)
         for a = 0 to 511
             for b = 0 to 511
                 file.read(l)
                 if l <> 0 then
                     if l = destLoc(l) then
                         if b < destMinX(l) then destMinX(l) = b
                         if b > destMaxX(l) then destMaxX(l) = b
                         if a < destMinY(l) then destMinY(l) = a
                         if a > destMaxY(l) then destMaxY(l) = a
                     else
                         destLoc(l) = l
                         destMinX(l) = b
                         destMaxX(l) = b
                         destMinY(l) = a
                         destMaxY(l) = a
'                         destLoc(destLocPtr) = l
'                         destMinX(destLocPtr) = b
'                         destMaxX(destLocPtr) = b
'                         destMinY(destLocPtr) = a
'                         destMaxY(destLocPtr) = a
                         destLocPtr = destLocPtr + 1
                     end if
                 end if
             next b
         next a
         file.close
         
         for a = 1 to 63
             if destloc(a) <> 0 then 
                 listbox1.additems "loc: " & right$("     " & str$(destLoc(a)),3) & "     minH" & right$("     " & str$(destMinX(a)),5) & "     maxH" & right$("     " & str$(destMaxX(a)),5) & "     minW" & right$("     " & str$(destMinY(a)),5) & "     maxW" & right$("     " & str$(destMaxY(a)),5)
                 call copyLocation(a)
             end if
             form.repaint
         next a
         listbox1.additems ""
     else
         listbox1.additems ""
         listbox1.additems " you must be positioned on a mission folder "
         listbox1.additems ""
     end if

END SUB

sub changeDirectory
    DIM File AS QFileStream
    dim f$
    dim i$
    i$ = ""
' for other than COL file
    edit5.visible = false
    edit6.visible = false
    edit7.visible = false
    edit8.visible = false
    edit9.visible = false
    edit10.visible = false
    sc8.visible = false
    sc9.visible = false
    sc10.visible = false
    sc11.visible = false
    button10.visible = false
    button11.visible = false
    showSelectionAsWhite.visible = false
    imediateChange.visible = false
    myTimer.enabled = false
    listbox1.visible = true
    listbox1.width = form.width - 50
    lbva.visible = false
    lbps.visible = false
    spinImage.visible = false
    pixelSize.visible = false
    sc11.visible = false
        grayScale.visible = false
        massChange.visible = false

'    dirTree.expand
    fileListBox1.directory = dirTree.directory
    edit1.text = dirTree.directory
    
    if ucase$(right$(edit1.text,9)) = "\MAPS.CA\" then
        listbox1.clear
        listbox1.additems ""
        listbox1.additems "  the map / mission editor stores its work files in these folders."
        listbox1.additems ""
        listbox1.additems "  you may look at the files in the MAP folders. "
        listbox1.additems ""
    end if    
    if left$(right$(edit1.text,9),4) = "\MAP" then
        f$ = edit1.text & "desc" 
        File.Open(f$, fmOpenRead)
        i$ = file.readline
        edit3.text = " map description: " & i$
        file.close
        listbox1.clear
        listbox1.additems ""
        listbox1.additems "  you may look at the files that make up the MAP folder. "
        listbox1.additems ""
        listbox1.additems "  cflags - ????"
        listbox1.additems ""
        listbox1.additems "  desc - ????"
        listbox1.additems ""
        listbox1.additems "  info - map type, height and width."
        listbox1.additems ""
        listbox1.additems "  landname - ????"
        listbox1.additems ""
        listbox1.additems "  objects - click to get a count of objects on the map."
        listbox1.additems ""
        listbox1.additems "  rhombs - terrain and brightness information."
    end if    
    if left$(right$(edit1.text,9),4) = "\MIS" then
        f$ = edit1.text & "desc" 
        File.Open(f$, fmOpenRead)
        i$ = file.readline
        edit3.text = " mission description: " & i$
        file.close
        listbox1.clear
        listbox1.additems ""
        listbox1.additems "  you may look at the files that make up the MIS folder. "
        listbox1.additems ""
        listbox1.additems "  use the button to the right to get mission documentation. "
        listbox1.additems ""
' disable copy
'        button5.visible = true
'        button8.visible = true
' document mission
        button9.visible = true
    else
        button5.visible = false
        button8.visible = false
        button9.visible = false
    end if    
    if right$(edit1.text,13) = "\DESC_COMMON\" then
        button6.visible = true
    else
        button6.visible = false
    end if    
end sub

sub selectFile
    
    edit1.text = ""    
    edit2.text = fileListBox1.filename
    listbox1.clear

    if ucase$(right$(edit2.text,3)) = "COL" then
        edit5.visible = true
        edit6.visible = true
        edit7.visible = true
        edit8.visible = true
        edit9.visible = true
        edit10.visible = true
        sc8.visible = true
        sc9.visible = true
        sc10.visible = true
        sc11.visible = true
'        button10.visible = true
'        button11.visible = true
'        imediateChange.visible = true
        button12.visible = true
        myTimer.enabled = true
        myTimer.interval = 1500
        myTimer.onTimer = onMyTimer
        showSelectionAsWhite.visible = true
        lbva.visible = true
        lbps.visible = true
        spinImage.visible = true
        pixelSize.visible = true
        sc11.visible = true
'        grayScale.visible = true
'        massChange.visible = true
        listbox1.visible = false
        listbox1.width = form.width - 390 '50
        button1.visible = false
        button2.visible = false
        button3.visible = false
        button4.visible = false
        edit4.visible = false
        colPalette.visible = true
        call colFile (edit2.text)
    else
' for other than COL file
        edit5.visible = false
        edit6.visible = false
        edit7.visible = false
        edit8.visible = false
        edit9.visible = false
        edit10.visible = false
        sc8.visible = false
        sc9.visible = false
        sc10.visible = false
        sc11.visible = false
        button10.visible = false
        button11.visible = false
        button12.visible = false
        myTimer.enabled = false
        myTimer.interval = 5000
        showSelectionAsWhite.visible = false
        imediateChange.visible = false
        lbva.visible = false
        lbps.visible = false
        spinImage.visible = false
        pixelSize.visible = false
        sc11.visible = false
        grayScale.visible = false
        massChange.visible = false
        listbox1.visible = true
        listbox1.width = form.width - 50
        button1.visible = true
        button2.visible = true
        button3.visible = true
        button4.visible = true
        edit4.visible = true
'        colPalette.visible = false
        colPalette.bmphandle = 320bmp
        
        if right$(edit2.text,6) = "rhombs" then
            call terrain
        elseif right$(edit2.text,6) = "cflags" then
            call blocked
        elseif right$(edit2.text,4) = "info" then
'            call hexDump
            if left$(right$(edit2.text,13),5) = "\MAP." then
                 call mapInfo (edit2.text)
            end if
            if left$(right$(edit2.text,13),5) = "\MIS." then
                 call missionInfo (edit2.text)
            end if
        elseif right$(edit2.text,7) = "objects" then
            call mapObject
        elseif ucase$(right$(edit2.text,3)) = "PCK" then
            call pckFile (edit2.text)
        else
            call hexDump
        end if
    end if
end sub

sub mapInfo (s as string)
'     listbox1.additems edit2.text
     listbox1.additems s
     DIM File AS QFileStream
     dim w1 as word
     dim w2 as word
     dim w3 as word
     dim w4 as word
     dim w5 as word
'     f$ = edit1.text & edit2.text 
     f$ = s 
     crlf! = 0
     lf! = 0
     chars! = 0
     hexSixe! = 16000
     File.Open(f$, fmOpenRead)
     file.read(w1)
     file.read(w2)
     file.read(w3)
     file.read(w4)
     file.read(w5)
     file.close
     glbMapType = w1
     glbHeight = w3
     glbWidth = w5
     listbox1.additems "map type " & str$(glbMapType) & "   height " & str$(glbHeight) & "   width " & str$(glbWidth)
     listbox1.additems ""
end sub

sub missionInfo (s as string)
'     listbox1.additems edit2.text
     listbox1.additems "mission information file: " & s
     DIM File AS QFileStream
     dim w1 as word
     dim w2 as word
     dim w3 as word
     dim w4 as word
     dim w5 as word
     dim w6 as word
     dim w7 as word
'     f$ = edit2.text 
     f$ = s 
     crlf! = 0
     lf! = 0
     chars! = 0
     hexSixe! = 16000
     File.Open(f$, fmOpenRead)
     file.read(w1)
     file.read(w2)
     file.read(w3)
     file.read(w4)
     file.read(w5)
     file.read(w6)
     file.read(w7)
     file.close
     glbMisHeight = w5
     glbMisWidth = w7
     listbox1.additems "mission   height " & str$(glbMisHeight) & "   width " & str$(glbMisWidth)
     listbox1.additems ""
end sub

sub editFile
    run "notepad.exe " & edit2.text
end sub

sub terrain
     listbox1.additems edit2.text
 'for hex display 
     DIM File AS QFileStream
     dim n!(4)

     dim w1 as word
     dim w2 as word
     dim w3 as word
     dim w4 as word
     dim w5 as word
          
     glbWhatInList = ""
     f$ = edit1.text & "info" 
     File.Open(f$, fmOpenRead)
     file.read(w1)
     file.read(w2)
     file.read(w3)
     file.read(w4)
     file.read(w5)
     file.close
     glbMapType = w1
     glbHeight = w3
     glbWidth = w5
     listbox1.additems "map type " & str$(glbMapType) & "   height " & str$(glbHeight) & "   width " & str$(glbWidth)
     listbox1.additems ""

     f$ = edit1.text & edit2.text 
     crlf! = 0
     lf! = 0
     chars! = 0
     hexSixe! = (2 * glbHeight) * glbWidth
     listbox1.additems ""
     File.Open(f$, fmOpenRead)
     ln! = 0
     while not file.eof and chars! < hexSixe!
' terrain - 4 x size of map - 128 x 4 = 512 ...
        i$ = file.readstr(4 * glbHeight)
        chars! = chars! + (4 * glbHeight)
'        listbox1.additems str$(len(i$)) & ":" & i$
        for b! = 0 to (glbHeight - 1)
            wk$ = mid$(i$,(b! * 4) + 1,4)
        ' swap bytes as if word type ...
            wk1$ = mid$(wk$,1,1)
            wk2$ = mid$(wk$,2,1)
            wk3$ = mid$(wk$,3,1)
            wk4$ = mid$(wk$,4,1)
            wk$ = wk2$ & wk1$ & wk4$ & wk3$
            bb$ = ""
            for a! = 1 to 4
                wchar$ = mid$(wk$, a!,1)
                
                p$ = p$ & right$(hex$(asc(wchar$)),2)
'                if b! < 5 then
                if b! < 2 then
                    b$ = right$("00000000" & bin$(asc(wchar$)),8)
                    bb$ = bb$ & b$ '& " " 
                    pb$ = "   " & left$(right$(hex$(asc(wchar$)),2),1)
                    pb$ = pb$ & "   " & right$(hex$(asc(wchar$)),1)
                    hb$ = hb$ & pb$ '& " " 
                end if
                n!(a!) = n!(a!) or asc(wchar$)

'                p$ = p$ & right$(hex$(asc(mid$(i$,(b! * 4) + a!,1))),2)
'                if b! < 5 then
'                    b$ = right$("00000000" & bin$(asc(mid$(i$,(b! * 4) + a!,1))),8)
'                    h$ = h$ & b$ '& " " 
''                    pb$ = "      " & right$(hex$(asc(mid$(i$,(b! * 4) + a!,1))),2)
'                    pb$ = "   " & left$(right$(hex$(asc(mid$(i$,(b! * 4) + a!,1))),2),1)
'                    pb$ = pb$ & "   " & right$(hex$(asc(mid$(i$,(b! * 4) + a!,1))),1)
'                    hb$ = hb$ & pb$ '& " " 
'                end if
'                n!(a!) = n!(a!) or asc(mid$(i$,(b! * 4) + a!,1))
            
            next a!

            h$ = h$ & bb$ & " "
            hb$ = hb$ & " "
            p$ = p$ & " "
        next b!    
'        listbox1.additems right$("     " & str$(ln!) & " ",6) & "........ ........ ...bbbbb ........  ........ ........ ...bbbbb ........  ........ ........ ...bbbbb ........  ........ ........ ...bbbbb ........  ........ ........ ...bbbbb ........"
' swapped bytes as if word type ...
'        hd$ = "...................bbbbb........ "
        hd$ = "...........................bbbbb "
        listbox1.additems right$("     " & str$(ln!) & " ",6) & hd$ & hd$ & " ... "
        listbox1.additems "      " & h$
        listbox1.additems "      " & hb$
'        listbox1.additems "      " & p$
        listbox1.additems ""
        p$ = ""
        h$ = ""
        pb$ = ""
        hb$ = ""
        ln! = ln! + 1
     wend
     q$ = chr$(n!(1)) & chr$(n!(2)) & chr$(n!(3)) & chr$(n!(4))
     p$ = ""
     for a! = 1 to 4
         p$ = p$ & right$(hex$(n!(a!)),2)  
     next a!
     b$ = right$("00000000000000000000000000000000" & convbase$(p$,16,2),32)
     file.close
     listbox1.additems ""
     listbox1.additems " or'd locations = " & p$ & " " & b$
     listbox1.additems ""
     brightBin$ = right$(b$,5)
     terrainBin$ = mid$(b$,23,5)
     restBin$ = left$(b$,22)
     listbox1.additems restBin$ & " " & terrainBin$ & " " & brightBin$
     listbox1.additems ""
     listbox1.additems mid$(b$,1,8) & " " & mid$(b$,9,8) & " " & mid$(b$,17,8) & " " & mid$(b$,25,8)
     listbox1.additems ""
end sub

sub mapObject
     listbox1.additems edit2.text
 'for hex display 
     DIM File AS QFileStream
     f$ = edit1.text & edit2.text 
     glbWhatInList = ""
     listbox1.additems ""
     dim w1 as word
     dim w2 as word
     dim w3 as word
     dim w4 as word
     dim ww1 as word
     dim ww2 as word
     dim ww3 as word
     dim ww4 as word
     dim ow1 as word
     dim ow2 as word
     dim ow3 as word
     dim ow4 as word
     dim allObj as long
     dim freeObj as long
     dim lyingObj as long
     dim standingObj as long
     dim trees as long
     dim streets as long
     dim buildings as long
     dim cliffs as long
     dim craters as long
     dim fences as long
     dim bridges as long
     allObj = 0
     freeObj = 0
     lyingObj = 0
     standingObj = 0
     trees = 0
     bridges = 0
     streets = 0
     buildings = 0
     cliffs = 0
     craters = 0
     fences = 0
     
'     f$ = edit1.text & "object" 
     File.Open(f$, fmOpenRead)
     p$ = ""
         ow1 = 0
         ow2 = 0
         ow3 = 0
         ow4 = 0
     while not file.eof 
' read 4 words at a time ...
         file.read(w1)
         file.read(w2)
         file.read(w3)
         file.read(w4)
'         if (w4 = 0) and ((w3 and 255) = 1) then
         if ((w3 and 255) = 1) then
         ' free objects
             p$ = right$("     " & str$(w1 \ 8),5) & " " & right$("     " & str$(w2 \ 8),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  free object           " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(freeObj)
'         elseif (w4 = 0) and ((w3 and 255) = 2) then
         elseif ((w3 and 255) = 2) then
         ' objects lying down
             p$ = right$("     " & str$(w1 \ 16),5) & " " & right$("     " & str$(w2 \ 16),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  object lying down     " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(lyingObj)
'         elseif (w4 = 0) and ((w3 and 255) = 3) then
         elseif ((w3 and 255) = 3) then
         ' standing objects 
             p$ = right$("     " & str$(w1 \ 16),5) & " " & right$("     " & str$(w2 \ 16),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  standing object       " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(standingObj)
'         elseif (w4 = 0) and ((w3 and 255) = 4) then
         elseif ((w3 and 255) = 4) then
         ' trees 
             p$ = right$("     " & str$(w1 \ 16),5) & " " & right$("     " & str$(w2 \ 16),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  tree                  " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(trees)
'         elseif (w4 = 0) and ((w3 and 255) = 5) then
         elseif ((w3 and 255) = 5) then
         ' streets
             p$ = right$("     " & str$(w1 \ 8),5) & " " & right$("     " & str$(w2 \ 8),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  street                " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(streets)
         elseif ((w3 and 255) = 6) then
         ' buildings
             p$ = right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  building              " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(buildings)
         elseif ((w3 and 255) = 8) then
         ' cliffs
             p$ = right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  cliff                 " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(cliffs)
         elseif ((w3 and 255) = 9) then
         ' craters
             p$ = right$("     " & str$(w1 \ 8),5) & " " & right$("     " & str$(w2 \ 8),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  crater                " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(craters)
         elseif ((w3 and 255) = 10) then
         ' bridges
             p$ = right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  bridge                " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(bridges)
         elseif ((w3 and 255) = 7) then
         ' fencess
             p$ = right$("     " & str$(w1 \ 16),5) & " " & right$("     " & str$(w2 \ 16),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & right$("     " & str$(w1 \ 32),5) & " " & right$("     " & str$(w2 \ 32),5)  
             p$ = p$ & "  fence                 " 
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
             inc(fences)
         else
             p$ = right$("     " & str$(w1),5) & " " & right$("     " & str$(w2),5) & " " & right$("     " & str$(w3),5) & " " & right$("     " & str$(w4),5)
             p$ = p$ & "  " & right$("0000" & convbase$(str$(w1),10,16), 4) & " " & right$("0000" & convbase$(str$(w2),10,16), 4) & " " & right$("0000" & convbase$(str$(w3),10,16), 4) & " " & right$("0000" & convbase$(str$(w4),10,16), 4)
             p$ = p$ & "  " & right$("0000000000000000" & convbase$(str$(w1),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w2),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w3),10,2),16) & " " & right$("0000000000000000" & convbase$(str$(w4),10,2),16)
             inc(allObj)
         end if
' sorted order ...         
'         for q! = 0 to listbox1.itemcount
'             if p$ < listbox1.item(q!) then
'                 listbox1.insertitem(q!,p$)
'                 exit for
'             end if
'         next q!

'         listbox1.additems p$
'         listbox1.repaint
         p$ = ""
         ow1 = ow1 or w1
         ow2 = ow2 or w2
         ow3 = ow3 or w3
         ow4 = ow4 or w4
         edit3.text = str$(allObj)
     wend
     file.close
     listbox1.additems ""
     listbox1.additems " object count = " & str$(allObj)
     listbox1.additems " free objects = " & str$(freeObj)
     listbox1.additems "   lying down = " & str$(lyingObj)
     listbox1.additems "     standing = " & str$(standingObj)
     listbox1.additems "        trees = " & str$(trees)
     listbox1.additems "      bridges = " & str$(bridges)
     listbox1.additems "      streets = " & str$(streets)
     listbox1.additems "    buildings = " & str$(buildings)
     listbox1.additems "       cliffs = " & str$(cliffs)
     listbox1.additems "      craters = " & str$(craters)
     listbox1.additems "       fences = " & str$(fences)
     listbox1.additems ""
     listbox1.additems " or'd value " & right$("0000000000000000" & bin$(ow1),16) & " " & right$("0000000000000000" & bin$(ow2),16) & " " & right$("0000000000000000" & bin$(ow3),16) & " " & right$("0000000000000000" & bin$(ow4),16)
     listbox1.additems ""
end sub

sub blocked
     DIM File AS QFileStream
     dim wd as word
     dim w1 as word
     dim w2 as word
     dim w3 as word
     dim w4 as word
     dim w5 as word
     
     glbWhatInList = "blocked"
     f$ = edit1.text & "info" 
     File.Open(f$, fmOpenRead)
     file.read(w1)
     file.read(w2)
     file.read(w3)
     file.read(w4)
     file.read(w5)
     file.close
     glbMapType = w1
     glbHeight = w3
     glbWidth = w5
     listbox1.additems "map type " & str$(glbMapType) & "   height " & str$(glbHeight) & "   width " & str$(glbWidth)
     listbox1.additems ""

     listbox1.additems edit2.text
     f$ = edit1.text & edit2.text 
     w5 = 0
     listbox1.additems ""
     File.Open(f$, fmOpenRead)
     while not file.eof 
        for b! = 0 to (glbHeight - 1)
            file.read(wd)
            p$ = p$ & right$("00000000" & bin$(wd),8)
'            p$ = p$ & bin$(wd)
            w5 = w5 or wd
            p$ = p$ & " "
        next b!    
        listbox1.additems p$
        p$ = ""
     wend
     file.close
     listbox1.additems ""
     listbox1.additems " or'd value " & right$("0000000000000000" & bin$(w5),16)
     listbox1.additems ""
end sub

sub sightHealthSpeed (Sender AS QBUTTON)
' list units by filename and 'Name'
     DIM File AS QFileStream
     DIM File2 AS QFileStream
     dim a!
     
     glbWhatInList = "sight"
     
     listbox1.clear

     button2.visible = true
     button3.visible = true
     button4.visible = true
     oDir$ = dirTree.directory 
'     dirTree.directory = "c:\program files\sudden strike\desc_common\units\"
     dirTree.directory = oDir$ & "units\"
     what$ = "1"
     listbox1.additems "  "
     listbox1.additems "zz"
myloop:
    for a! = 0 to filelistbox1.itemcount - 1     
         f$ = dirTree.directory & filelistbox1.item(a!)
'     listbox1.additems " -> " & f$
'     edit3.text = " -> " & f$
         form.repaint
         File.Open(f$, fmOpenRead)
         who$ = ""
         whow$ = ""
         nation$ = ""
         namew$ = ""
         sightw$ = ""
         healthw$ = ""
         moveSpeedw$ = ""
         name$ = ""
         sight$ = ""
         health$ = ""
         moveSpeed$ = ""
         defSight$ = ""
         defMoveSpeed$ = ""
         defHealth$ = ""
         lunit$ = ""
         hu1$ = ""
         hu2$ = ""
         hu3$ = ""
         hu4$ = ""
         hu5$ = ""
         hu6$ = ""
         hu7$ = ""
         while not file.eof
             i$ = file.readline
             if ucase$(left$(i$,4)) = "NAME" then
                 name$ = i$
                 namew$ = lastpart(i$)
             end if
             if ucase$(left$(i$,5)) = "SIGHT" then
                 sight$ = i$
                 sightw$ = lastpart(i$)
             end if
             if ucase$(left$(i$,9)) = "MOVESPEED" then
                 moveSpeed$ = i$
                 moveSpeedw$ = lastpart(i$)
             end if
             if ucase$(left$(i$,6)) = "HEALTH" then
                 health$ = i$
                 healthw$ = lastpart(i$)
             end if
             if ucase$(left$(i$,11)) = "*NATIONTYPE" then
                 nation$ = i$
                 who$ = lastpart(i$)
                 whow$ = firstpart(who$) & "-" & lastpart(who$)
             end if
             if left$(i$,1) = "#" or left$(i$,1) = "@" then
'             if left$(i$,1) = "!" or left$(i$,1) = "!" then
                 if hu1$ = "" then 
                     hu1$ = "     " & i$
                 elseif hu2$ = "" then
                     hu2$ = "     " & i$
                 elseif hu3$ = "" then
                     hu3$ = "     " & i$
                 elseif hu4$ = "" then
                     hu4$ = "     " & i$
                 elseif hu5$ = "" then
                     hu5$ = "     " & i$
                 elseif hu6$ = "" then
                     hu6$ = "     " & i$
                 elseif hu7$ = "" then
                     hu7$ = "     " & i$
                 end if
                 if left$(i$,3) = "#hu" then
'                 if left$(i$,1) = "#" then
'                     f2$ = "c:\program files\sudden strike\desc_common\" & mid$(i$,2,255)
                     f2$ = oDir$ & mid$(i$,2,255)
'     listbox1.additems " #-> " & f2$
'     edit3.text = " #-> " & f2$
                     File2.Open(f2$, fmOpenRead)
                     while not file2.eof
                         i2$ = file2.readline
                         if left$(i2$,5) = "Sight" then
                             defSight$ = i2$
                             sightw$ = lastpart(i2$) & "*"
                         end if
                         if left$(i2$,9) = "MoveSpeed" then
                             defMoveSpeed$ = i2$
                             moveSpeedw$ = lastpart(i2$) & "*"
                         end if
                         if left$(i2$,6) = "Health" then
                             defHealth$ = i2$
                             healthw$ = lastpart(i2$) & "*"
                         end if
                     wend
                     file2.close
                 end if
                 
                 if left$(i$,6) = "#units" then
                     lUnit$ = i$
                     f2$ = oDir$ & mid$(i$,2,255)
                     if fileExists(f2$) = false then
                          f2$ = oDir$ & "common\" & mid$(i$,2,255)
                          if fileExists(f2$) = false then
                              f2$ = ""
                          end if
                     end if
                     if f2$ <> "" then
                         File2.Open(f2$, fmOpenRead)
                         while not file2.eof
                             i2$ = file2.readline
                             if left$(i2$,5) = "Sight" then
                                 defSight$ = i2$
                                 sightw$ = lastpart(i2$) & "*"
                             end if
                             if left$(i2$,9) = "MoveSpeed" then
                                 defMoveSpeed$ = i2$
                                 moveSpeedw$ = lastpart(i2$) & "*"
                             end if
                             if left$(i2$,6) = "Health" then
                                 defHealth$ = i2$
                                 healthw$ = lastpart(i2$) & "*"
                             end if
                         wend
                         file2.close
                     end if
                 end if
             end if
         wend
         if name$ <> "" then
           dothis = false
           if dothis then
             listbox1.additems f$
             listbox1.additems name$
             if nation$ <> "" then listbox1.additems nation$
             if hu1$ <> "" then listbox1.additems "     " & hu1$
             if hu2$ <> "" then listbox1.additems "     " & hu2$
             if hu3$ <> "" then listbox1.additems "     " & hu3$
             if hu4$ <> "" then listbox1.additems "     " & hu4$
             if hu5$ <> "" then listbox1.additems "     " & hu5$
             if hu6$ <> "" then listbox1.additems "     " & hu6$
             if hu7$ <> "" then listbox1.additems "     " & hu7$
             if defSight$ <> "" then listbox1.additems "# " & defSight$
             if defHealth$ <> "" then listbox1.additems "# " & defHealth$
             if defMoveSPeed$ <> "" then listbox1.additems "# " & defMoveSPeed$
             if sight$ <> "" then listbox1.additems sight$
             if health$ <> "" then listbox1.additems health$
             if moveSpeed$ <> "" then listbox1.additems moveSpeed$
             listbox1.additems ""
           else
             if lunit$ <> "" then namew$ = namew$ & " <<< " & lunit$
             w$ = whow$ & space$(15 - len(whow$))
             w$ = w$ & namew$ & space$(53 - len(namew$))
             w$ = w$ & sightw$ & space$(9 - len(sightw$))
             w$ = w$ & healthw$ & space$(7 - len(healthw$))
             w$ = w$ & moveSpeedw$ & space$(15 - len(moveSpeedw$))
             w$ = w$ & f$
             for q! = 0 to listbox1.itemcount
                 if w$ < listbox1.item(q!) then
                     listbox1.insertitem(q!,w$)
                     exit for
                 end if
             next q!
'             listbox1.additems w$
           end if
         end if
         
         file.close
    next a!
    if what$ = "1" then
        what$ = "2"
        dirTree.directory = oDir$ & "common\units\"
        goto myloop
    end if
    listbox1.insertItem(0, "who            unit description                                     sight   health  speed")
    listbox1.delItems listbox1.itemcount -1
end sub

sub listBox1onChange
    t$ = ""
    p$ = ""
    li! = 0
    for a! = 0 to listbox1.itemCount - 1
        if listbox1.selected(a!) = 1 then 
            t$ = listbox1.item(a!) 
            li! = a!
        end if
    next a!
    for a! = 1 to len(t$)
        p$ = p$ & right$(hex$(asc(mid$(t$,a!,1))),2) & " "
    next a!
    
' in col display
    if glbWhatInList = "colfile" then
        for a! = 0 to listbox1.itemCount - 1
            if listbox1.selected(a!) = 1 then 
                '
                sc8.position = (colValue(a!) and &HF800) / 2048
                sc9.position = (colValue(a!) and &H07E0) / 32
                sc10.position = colValue(a!) and &H001F
                glbColPtr = a!
'                call colchange
            end if
        next a!
'    messagebox(p$,"hex",1)
' in unit display
    elseif glbWhatInList = "sight" then
'        messagebox(right$(t$, len(t$) - 99),"all",1)
        t$ = right$(t$, len(t$) - 99)
        run "notepad.exe " & t$
    elseif glbWhatInList = "pckfile" then
' in pck display
        listbox1.additems "  image " & str$(li!) & " " & str$(pfStart(li!)) & " " & str$(pfEnd(li!)) & " " 
        call pckImage(glbPCKFileName, pfStart(li!), pfEnd(li!))
    else
        messagebox(t$,"all",1)
    end if
    
end sub

function firstPart (gw$) as string
    for a! = 1 to len(gw$)
        if mid$(gw$, a!, 1) < chr$(33) then
            f$ = left$(gw$, a! - 1)
            l$ = right$(gw$, len(gw$) - a!)
            while left$(l$, 1) < chr$(33)
                l$ = mid$(l$, 2)
            wend
            exit for
        end if
    next a!
    firstPart = f$
end function

function lastPart (gw$) as string
    for a! = 1 to len(gw$)
        if mid$(gw$, a!, 1) < chr$(33) then
            f$ = left$(gw$, a! - 1)
            l$ = right$(gw$, len(gw$) - a!)
            while left$(l$, 1) < chr$(33)
                l$ = mid$(l$, 2)
            wend
            exit for
        end if
    next a!
    lastPart = l$
end function

sub searchListbox (Sender as QBUTTON)
dim xs$
dim a!
dim srch$
    xs$ = ucase$(edit4.text)
    if xs$ <> "" then
        for a! = 0 to listbox1.itemCount - 1
            srch$ = " " & ucase$(listbox1.item(a!)) & " "
            if instr(srch$,xs$) > 0 then
                listbox1.selected(a!) = 1
            else
                listbox1.selected(a!) = 0
            end if
        next a!
    end if
end sub

'--------------------------------------------------------------
sub onMyTimer()
    myTimer.interval = 1500
    if spinImage.checked then
        if sc11.position = 31 then
            sc11.position = 0
        else
            sc11.position = sc11.position + 1
        end if
    end if
end sub

sub cvtCol (ssCol as word, BYREF r as word, BYREF g as word, BYREF b as word, BYREF bt as word)
' 5 6 5 format
     r = (ssCol and &HF800) / 2048
     g = (ssCol and &H07E0) / 32
     b = ssCol and &H001F
     bt = 0
end sub

function winCol (r as word, g as word, b as word, bt as word) as long
dim redX as word
dim greenX as word
dim blueX as word
dim redV as word
dim greenV as word
dim blueV as word
    
    if edit7.text = "" then redX = 1 else redX = val(edit7.text)
    if edit6.text = "" then greenX = 1 else greenX = val(edit6.text) 
    if edit5.text = "" then blueX = 1 else blueX = val(edit5.text)
    
'    blueV = (255 * (b / 31)) and 255
'    greenV = (255 * (g / 63)) and 255
'    redV = (255 * (r / 31)) and 255
   
    blueV = b * blueX
    greenV = g * greenX
    redV = r * redX
    
    if blueV > 255 then blueV = 255
    if greenV > 255 then greenV = 255
    if redV > 255 then redV = 255
    
    winCol = (blueV * &H010000) + (greenV * &H000100) + (redV)
    
end function

sub colChange()
' one of the color sliders has changed ....
    dim redV as word
    dim greenV as word
    dim blueV as word
    dim redS as word
    dim greenS as word
    dim blueS as word
    dim bt as word
    dim a as word
    dim red%
    dim green%
    dim blue%
    
    dim w5 as long
    if glbSkipChange then exit sub
     
    edit8.text = str$(sc8.position)
    edit9.text = str$(sc9.position)
    edit10.text = str$(sc10.position)

' rapid-q is blue green red format ...
    blueV = sc10.position
    greenV = sc9.position
    redV = sc8.position
    
    w5 = winCol (redV, greenV, blueV, 0)
    form.fillrect (680, 610, 780, 700, w5)
    if (glbPaletteEndSelection < 0) and imediateChange.checked then
        
        call saveColValue
        call drawPalette
    elseif (glbPaletteEndSelection > 0) then
    ' alter selected colors
'        for a = glbPaletteSelection to glbPaletteEndSelection
'            call cvtCol (colValue(a), @redS, @greenS, @blueS, @bt)
'            red% = redS + redV - tRed
'            green% = greenS + greenV - tGreen
'            blue% = blueS + blueV - tBlue
'            if red% < 0 then redS = 0
'            if green% < 0 then greenS = 0
'            if blue% < 0 then blueS = 0
'            if red% > 31 then redS = 31
'            if green% > 63 then greenS = 63
'            if blue% > 31 then blueS = 31
'            colValue(a) = blueS + (greenS * 32) + (redS * 2048)
'        next a
        tRed = redV : tGreen = greenV : tBlue = blueV
        call drawPalette
        tRed = 0 : tGreen = 0 : tBlue = 0
    end if
end sub

sub saveColValue()
    if glbPaletteSelection < 300 then
        colValue(glbPaletteSelection) = (sc10.position) + (sc9.position * 32) + (sc8.position * 2048)
        call drawPalette
        if not spinImage.checked then
            call vuChange
        end if
    end if
end sub

sub imediateChanged
    if imediateChange.checked then
        button10.visible = false
        button10.enabled = false
    else
        button10.visible = true
        button10.enabled = true
    end if
end sub

sub findSimilarShades
dim a as integer
dim redV as word
dim greenV as word
dim blueV as word
dim redS as word
dim greenS as word
dim blueS as word
dim red%
dim green%
dim blue%
dim bt as word
dim diff as word
dim x as word
dim y as word

    call drawPalette
    diff = 5
    call cvtCol (colValue(glbPaletteSelection), @redS, @greenS, @blueS, @bt)
    for a = 0 to glbColMax - 1
        call cvtCol (colValue(a), @redV, @greenV, @blueV, @bt)
        if (redV > (redS - diff)) and (redV < (redS + diff)) then
            if (greenV > (greenS - diff)) and (greenV < (greenS + diff)) then
                if (blueV > (blueS - diff)) and (blueV < (blueS + diff)) then
                    y = a \ 16
                    x = a - (y * 16)
                    colPalette.rectangle ((x * 20), (y * 20),(x * 20) + 20, (y * 20) + 20, &HFFFFFF)
                end if
            end if
        end if
    next a
    
end sub

sub findSimilarColors
dim a as integer
dim redV as word
dim greenV as word
dim blueV as word
dim redS as word
dim greenS as word
dim blueS as word
dim red%
dim green%
dim blue%
dim bt as word
dim diff as word
dim x as word
dim y as word
dim rgDiff as integer
dim bgDiff as integer
dim wrgDiff as integer
dim wbgDiff as integer

    call drawPalette
    diff = 1
    call cvtCol (colValue(glbPaletteSelection), @redS, @greenS, @blueS, @bt)
    rgDiff = redS - (greenS / 2)
    bgDiff = blueS - (greenS / 2)
    for a = 0 to glbColMax - 1
        call cvtCol (colValue(a), @redV, @greenV, @blueV, @bt)
        wrgDiff = redV - (greenV / 2)
        wbgDiff = blueV - (greenV / 2)
        if (wrgDiff > (rgDiff - diff)) and (wrgDiff < (rgDiff + diff)) then
            if (wbgDiff > (bgDiff - diff)) and (wbgDiff < (bgDiff + diff)) then
                    y = a \ 16
                    x = a - (y * 16)
                    colPalette.rectangle ((x * 20), (y * 20),(x * 20) + 20, (y * 20) + 20, &HFFFFFF)
            end if
        end if
    next a
    
end sub

sub saveMassChanges()
dim a as integer
dim redV as word
dim greenV as word
dim blueV as word
dim red%
dim green%
dim blue%
dim bt as word
        
'    blueV = sc10.position
'    greenV = sc9.position
'    redV = sc8.position
    grayScale.visible = false
    massChange.visible = false
    button10.visible = true
    button11.visible = true
    imediateChange.visible = true
    
    for a = glbPaletteSelection to glbPaletteEndSelection
        call cvtCol (colValue(a), @redV, @greenV, @blueV, @bt)
        if glbGrayScale then
        ' average for gray scale
            red% = (redV + (greenV / 2) + blueV) / 3
            if red% < 0 then redV = 0
            if red% > 31 then redV = 31
            greenV = redV * 2
            blueV = redV
        else
        ' alter 
            red% = redV * (sc8.position / 15)
            green% = greenV * (sc9.position / 31)
            blue% = blueV * (sc10.position / 15)
            redV = red%
            greenV = green%
            blueV = blue%
            if red% < 0 then redV = 0
            if green% < 0 then greenV = 0
            if blue% < 0 then blueV = 0
            if red% > 31 then redV = 31
            if green% > 63 then greenV = 63
            if blue% > 31 then blueV = 31
        end if
        colValue(a) = (blueV) + (greenV * 32) + (redV * 2048)
    next a
    glbPaletteEndSelection = -1
    glbGrayScale = 0
    call drawPalette
end sub

sub grayScaleChanges()
    glbGrayScale = 1
    call drawPalette
'    glbGrayScale = 0
end sub

sub saveColFile()
     DIM File AS QFileStream
     dim a as word
     File.Open(glbColFileName, fmOpenWrite)
     for a = 0 to glbColMax - 1
         file.write(colValue(a))
     next a    
     file.close
end sub

sub drawPalette
    dim a as word
    dim x as word
    dim y as word
    dim redV as word
    dim greenV as word
    dim blueV as word
    dim red%
    dim green%
    dim blue%
    dim bt as word

'    listbox1.clear
    for a = 0 to glbColMax - 1
        call cvtCol (colValue(a), @redV, @greenV, @blueV, @bt)
        if (a >= glbPaletteSelection and a <= glbPaletteEndSelection) then
            if glbGrayScale then
            ' average for gray scale
                red% = (redV + (greenV / 2) + blueV) / 3
                if red% < 0 then redV = 0
                if red% > 31 then redV = 31
                greenV = redV * 2
                blueV = redV
            else
            ' t variables for showing mass changes
                red% = redV * (tRed / 15)
                green% = greenV * (tGreen / 31)
                blue% = blueV * (tBlue / 15)
                redV = red%
                greenV = green%
                blueV = blue%
                if red% < 0 then redV = 0
                if green% < 0 then greenV = 0
                if blue% < 0 then blueV = 0
                if red% > 31 then redV = 31
                if green% > 63 then greenV = 63
                if blue% > 31 then blueV = 31
            end if
        end if
        WINcolValue(a) = winCol (redV, greenV, blueV, bt)
        y = a \ 16
        x = a - (y * 16)
        colPalette.fillrect ((x * 20), (y * 20),(x * 20) + 20, (y * 20) + 20, WINcolValue(a))
        if (a = glbPaletteSelection) or (a >= glbPaletteSelection and a <= glbPaletteEndSelection) then
            colPalette.rectangle ((x * 20), (y * 20),(x * 20) + 20, (y * 20) + 20, &HFFFFFF)
        end if
    next a
end sub


sub colFile (f$ as string)
    DIM File AS QFileStream
    dim wd as word
    dim w1 as word
    dim w2 as word
    dim w3 as word
    dim w4 as word
    dim w5 as long
    dim fc as word
    dim a as word
    dim x as word
    dim y as word
    dim redV as word
    dim greenV as word
    dim blueV as word
    dim bt as word

    listbox1.width = form.width - 390 '50
    
    colPalette.fillrect (1,1,320,320,&H000000)
     
    if ucase$(right$(f$, 7)) = "STR.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 8)) = "PARA.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 11)) = "MACHGUN.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 10)) = "MORT40.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 11)) = "MORT160.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 10)) = "MORTAR.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 9)) = "MORT6.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 12)) = "PLAN_DRP.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 8)) = "SHOT.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    if ucase$(right$(f$, 8)) = "T-44.COL" then
        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
        exit sub
    end if 
     
    glbWhatInList = "colfile"
    File.Open(f$, fmOpenRead)
    glbColFileName = f$
    fc = 0
    listbox1.clear
    while not file.eof
        file.read(w1)
        colValue(fc) = w1
        fc = fc + 1
    wend
    glbColMax = fc
    file.close
    call drawPalette
' figure out name of PCK file
    f$ = left$(f$,len(f$) - 3) & "pck"
' set up image pointers
    call loadFile(f$)
    call vuChange
    
end sub

sub clickedImage (b%, x%, y%, s%)
    dim redV as word
    dim greenV as word
    dim blueV as word
    dim bt as word
    edit1.text = str$(myImage.pixel(x%,y%))
    glbGrayScale = 0
    glbPaletteEndSelection = -1
    showSelectionAsWhite.checked = true
    for a = 0 to glbColMax - 1
        if myImage.pixel(x%,y%) = WINcolValue(a) then
            glbPaletteSelection = a
            if showSelectionAsWhite.checked then
                glbDisplayAsWhite = a
            else
                glbDisplayAsWhite = 500
            end if    
' set color sliders    
            call cvtCol (colValue(a), @redV, @greenV, @blueV, @bt)
            glbSkipChange = 1
            sc8.position = redV
            sc9.position = greenV
            sc10.position = blueV
            glbSkipChange = 0
            call colChange
            call drawPalette
            call vuChange
        end if
    next a
end sub

sub clickedPalette (b%, x%, y%, s%)
    dim w as word
    dim x as word
    dim y as word
    dim redV as word
    dim greenV as word
    dim blueV as word
    dim bt as word
    dim a as word

' determine color array pointer    
    w = ((y% \ 20) * 16) + (x% \ 20)
    glbGrayScale = 0
    if b% = 0 then 
    ' left button clicked
        glbPaletteSelection = w
        glbPaletteEndSelection = -1

        if showSelectionAsWhite.checked then
            glbDisplayAsWhite = w
        else
            glbDisplayAsWhite = 500
        end if
        edit1.text = str$(x%) & "   " & str$(y%) & " -- " & str$(wx) & "   " & str$(wy) & " --  " & str$(w) & " button:" & str$(b%)
' set color sliders    
        call cvtCol (colValue(w), @redV, @greenV, @blueV, @bt)
        glbSkipChange = 1
        sc8.position = redV
        sc9.position = greenV
        sc10.position = blueV
        glbSkipChange = 0
        call colChange
        call drawPalette
        call vuChange
        grayScale.visible = false
        massChange.visible = false
        button10.visible = true
        button11.visible = true
        imediateChange.visible = true
    end if    
    if b% = 1 then 
    ' right button clicked
        if w < glbPaletteSelection then
        ' if the color selected by right button is less than the
        ' color selected by the left button ...
        ' clear end
            glbPaletteEndSelection = -1
            grayScale.visible = false
            massChange.visible = false
            button10.visible = true
            button11.visible = true
            imediateChange.visible = true
        else
        ' set the end of selection 
            glbPaletteEndSelection = w
            tRed = 15 : tGreen = 31 : tBlue = 15 : tColors = 0
            ' skip recalc while we change the color sliders ...
            glbSkipChange = 1
            sc8.position = tRed 
            sc9.position = tGreen 
            sc10.position = tBlue 
            glbSkipChange = 0
            grayScale.visible = true
            massChange.visible = true
            button10.visible = false
            button11.visible = false
            imediateChange.visible = false
        end if
        call drawPalette
    end if
end sub

sub colorOrCompression()
    if button12.caption = "show compression" then
        button12.caption = "show colors"
    else
        button12.caption = "show compression"
    end if
    call vuChange
end sub

sub drawSmallImage()
dim i as qimage
    if fileExists(origdir$ & "\bkgrd.bmp") then
        i.bmp = origdir$ & "\bkgrd.bmp"
    else
        i.bmphandle = bkgrdBMP
    end if
' testing canvas 
    myCanvas.draw (0,0,i.bmp)
    call drawMyImage(glbPCKFileName, pfStart(1 + sc11.position), pfEnd(1 + sc11.position), 110, 110, 5)
    call drawMyImage(glbPCKFileName, pfStart(33 + sc11.position), pfEnd(33 + sc11.position), 110, 110, 5)
    if glbTurret > 286 then
        call drawMyImage(glbPCKFileName, pfStart(193 + sc11.position), pfEnd(193 + sc11.position), 110, 110, 5)
    end if
end sub

sub vuChange()
    call drawSmallImage
' clear form
    myImage.fillrect(0,0,320,320,&Hffffff)
' shadows ...
    call drawImage(glbPCKFileName, pfStart(161 + sc11.position), pfEnd(161 + sc11.position), 160, 160, 5)
    if glbTurret > 286 then
        call drawImage(glbPCKFileName, pfStart(257 + sc11.position), pfEnd(257 + sc11.position), 160, 160, 5)
    end if
' image ...
    call drawImage(glbPCKFileName, pfStart(1 + sc11.position), pfEnd(1 + sc11.position), 160, 160, 5)
    call drawImage(glbPCKFileName, pfStart(33 + sc11.position), pfEnd(33 + sc11.position), 160, 160, 5)
    if glbTurret > 286 then
        call drawImage(glbPCKFileName, pfStart(193 + sc11.position), pfEnd(193 + sc11.position), 160, 160, 5)
    end if

' draw individual normal images
'    call drawImage(glbPCKFileName, pfStart(1 + sc11.position), pfEnd(1 + sc11.position), 30, 160, 2)
'    call drawImage(glbPCKFileName, pfStart(33 + sc11.position), pfEnd(33 + sc11.position), 30, 240, 2)
'    if glbTurret > 286 then
'        call drawImage(glbPCKFileName, pfStart(193 + sc11.position), pfEnd(193 + sc11.position), 30, 80, 2)
'    end if
' draw individual damaged images
'    if glbTurret > 66 then
'        call drawImage(glbPCKFileName, pfStart(97 + sc11.position), pfEnd(97 + sc11.position), 290, 160, 2)
'        call drawImage(glbPCKFileName, pfStart(129 + sc11.position), pfEnd(129 + sc11.position), 290, 240, 2)
'        if glbTurret > 286 then
'            call drawImage(glbPCKFileName, pfStart(225 + sc11.position), pfEnd(225 + sc11.position), 290, 80, 2)
'        end if
'    end if
end sub

sub loadFile (f$ as string)
' set up pinters to images within this file
    DIM File AS QFileStream
    dim ptrWork as long
    dim imStart as long
    dim imEnd as long
    dim wHshift as short
    dim wVshift as short
    dim wWidth as short
    dim wHeight as short
    dim wb as byte
    dim o$
    dim images as integer
    
'    if ucase(right$(f$, 8)) = "T-44.PCK" then
'        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
'        exit sub
'    end if 
'    
'    if ucase(right$(f$, 8)) = "STR.PCK" then
'        form.textout(100,400,"can't do that one", &Hffffff, &H000000)
'        exit sub
'    end if 
    
    glbPCKFileName = f$
    
    File.Open(f$, fmOpenRead)
    ptrWork = 0
    images = 1
    imEnd = 0
    while imEnd < file.size
    edit1.text = " image " & str$(images)
   ' position to offset ...
         file.position = ptrWork
     
         file.read(imStart)
   ' save offset for next image
         ptrWork = file.position
         
   ' get start of next image for use as end of this image
         file.read(imEnd)
   ' image ...
         pfStart(images) = imStart
         pfEnd(images) = imEnd
         images = images + 1
     wend
          
     file.close
     glbTurret = images
     
end sub

sub drawImagePixel()
end sub

sub drawImage(f$ as string, startOfImage as long, endOfImage as long, xp as word, yp as word, s as word)
    DIM File AS QFileStream
    dim wHshift as short
    dim wVshift as short
    dim wWidth as short
    dim wHeight as short
    dim ptrWork as long
    dim wb as byte
    dim iLength as word
    dim iData as byte
    dim iPixel as byte
    dim a as word
    dim b as word
    dim formXoffset as word
    dim formYoffset as word
    dim pixSize as word
    
    File.Open(f$, fmOpenRead)
    file.position = startOfImage     

    file.read(wHshift)
    file.read(wVshift)
    file.read(wWidth)
    file.read(wHeight)
    file.read(wb)

    
    formXoffset = xp
    formYoffset = yp
'    pixSize = s
    pixSize = pixelSize.position
    listbox1.visible = false
    
    y = 1
' work on image line
    ptrWork = file.position
    while ptrWork < endOfImage
        h$ = ""
        x = 1
        file.read(iLength)
        ptrWork = file.position + iLength 
        l$ = ""
        
        if ptrWork > endOfImage then
            listbox1.additems " bad stuff "
            listbox1.additems h$
            listbox1.additems "    ------------    "
            listbox1.additems ""
            exit sub
        end if
        
        ' iLength has number of bytes in line
        ' positioned at line data
        while file.position < ptrWork
            ' image data
'    listbox1.additems " pixel data "
            file.read(iData)
            
            if wb = 162 then    
                if iData > &HC0 then
                ' empty pixels for iData - 192
                    for b = 1 to iData - 192
                        l$ = l$ & "_"
                        x = x + 1
                    next b
                elseif iData > &H80 then
                ' repeated data for iData - 128
                    file.read(iPixel)
                    for b = 1 to iData - 128
                        l$ = l$ & "R"
        
                        if button12.caption = "show colors" then
                            myImage.fillrect (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),&HFF0000)
                        else
                            myImage.fillrect (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),WINcolValue(iPixel))
'                            if glbDisplayAsWhite = iPixel then
                            if (iPixel = glbPaletteSelection) or (iPixel >= glbPaletteSelection and iPixel <= glbPaletteEndSelection) then
                            ' display the selected color as white
                                if showSelectionAsWhite.checked then myImage.rectangle (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),&HFFFFFF)
                            end if
                        end if
                        
                        x = x + 1
                    next b
                elseif iData > &H40 then
                ' soft drawn
                    for b = 1 to iData - 64
                        file.read(iPixel)
                        l$ = l$ & "S"
                        if button12.caption = "show colors" then
                            myImage.fillrect (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),&H0000FF)
                        else
                            myImage.fillrect (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),WINcolValue(iPixel))
'                            if glbDisplayAsWhite = iPixel then
                            if (iPixel = glbPaletteSelection) or (iPixel >= glbPaletteSelection and iPixel <= glbPaletteEndSelection) then
                            ' display the selected color as white
                                if showSelectionAsWhite.checked then myImage.rectangle (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),&HFFFFFF)
                            end if
                        end if
                        x = x + 1
                    next b
                else
                ' normal
                    for b = 1 to iData 
                        file.read(iPixel)
                        l$ = l$ & "N"
                        if button12.caption = "show colors" then
                            myImage.fillrect (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),&H00FF00)
                        else
                            myImage.fillrect (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),WINcolValue(iPixel))
'                            if glbDisplayAsWhite = iPixel then
                            if (iPixel = glbPaletteSelection) or (iPixel >= glbPaletteSelection and iPixel <= glbPaletteEndSelection) then
                            ' display the selected color as white
                                if showSelectionAsWhite.checked then myImage.rectangle (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),&HFFFFFF)
                            else
                            end if
                        end if
                        x = x + 1
                    next b
                end if
            else

' 163 type
                if iData > &H80 then
                ' empty pixels for iData - 192
                    for b = 1 to iData - 128
                        l$ = l$ & "_"
                        x = x + 1
                    next b
                else
                ' normal - draw shadow
                    for b = 1 to iData 
                        l$ = l$ & "N"
                        myImage.fillrect (formXoffset + ((x + wHshift) * pixSize),formYoffset + ((y  + wVshift) * pixSize),formXoffset + pixSize + ((x + wHshift) * pixSize),formYoffset + pixSize + ((y  + wVshift) * pixSize),&H808080)
                        x = x + 1
                    next b
                end if
            
            end if
        wend    
    y = y + 1
    wend
    file.close
end sub

sub drawMyImage(f$ as string, startOfImage as long, endOfImage as long, xp as word, yp as word, s as word)
    DIM File AS QFileStream
    dim wHshift as short
    dim wVshift as short
    dim wWidth as short
    dim wHeight as short
    dim ptrWork as long
    dim wb as byte
    dim iLength as word
    dim iData as byte
    dim iPixel as byte
    dim a as word
    dim b as word
    dim formXoffset as word
    dim formYoffset as word
    dim pixSize as word
    
    File.Open(f$, fmOpenRead)
    file.position = startOfImage     

    file.read(wHshift)
    file.read(wVshift)
        file.read(wWidth)
    file.read(wHeight)
    file.read(wb)

    formXoffset = xp
    formYoffset = yp
    pixSize = s
    listbox1.visible = false
    
    y = 1
' work on image line
    ptrWork = file.position
    while ptrWork < endOfImage
        x = 1
        file.read(iLength)
        ptrWork = file.position + iLength 
        
        if ptrWork > endOfImage then
            listbox1.additems " bad stuff "
            listbox1.additems "    ------------    "
            listbox1.additems ""
            exit sub
        end if
        
        ' iLength has number of bytes in line
        ' positioned at line data
        while file.position < ptrWork
            ' image data
'    listbox1.additems " pixel data "
            file.read(iData)
            if iData > &HC0 then
    ' empty pixels for iData - 192
                for b = 1 to iData - 192
                    x = x + 1
                next b
            elseif iData > &H80 then
            ' repeated data for iData - 128
                file.read(iPixel)
                for b = 1 to iData - 128
                    myCanvas.pSet (formXoffset + x + wHshift,formYoffset + y  + wVshift,WINcolValue(iPixel))
                    x = x + 1
                next b
            elseif iData > &H40 then
            ' soft drawn
                for b = 1 to iData - 64
                    file.read(iPixel)
                    myCanvas.pSet (formXoffset + x + wHshift,formYoffset + y  + wVshift,WINcolValue(iPixel))
                    x = x + 1
                next b
            else
            ' normal
                for b = 1 to iData 
                    file.read(iPixel)
                    myCanvas.pSet (formXoffset + x + wHshift,formYoffset + y  + wVshift,WINcolValue(iPixel))
                    x = x + 1
                next b
            end if
        wend    
    y = y + 1
    wend
    file.close
end sub

sub pckFile (f$ as string)
    DIM File AS QFileStream
    dim ptrWork as long
    dim imStart as long
    dim imEnd as long
    dim wHshift as short
    dim wVshift as short
    dim wWidth as short
    dim wHeight as short
    dim wb as byte
    dim o$
    dim images as integer
     
'    glbWhatInList = "pckfile"
    glbPCKFileName = f$

    listbox1.width = form.width - 50
    
    File.Open(f$, fmOpenRead)
    listbox1.clear
    listbox1.additems f$ & " file size " & right$("00000000" & hex$(file.size),8) & "  " & str$(file.size)

    ptrWork = 0
    images = 1
    imEnd = 0
    while imEnd < file.size
    edit1.text = " image " & str$(images)
   ' position to offset ...
         file.position = ptrWork
     
         file.read(imStart)
   ' save offset for next image
         ptrWork = file.position
         
   ' get start of next image for use as end of this image
         file.read(imEnd)
   ' image ...
         listbox1.additems " image " & str$(images) & " - start " & right$("00000000" & hex$(imStart),8) & " end " & right$("00000000" & hex$(imEnd),8)
         
         pfStart(images) = imStart
         pfEnd(images) = imEnd
         
         call pckImage(f$, imStart, imEnd)
         
         images = images + 1
     wend
          
     file.close
     listbox1.additems ""
     listbox1.additems "-- image count " & str$(images - 1)
end sub

sub pckImage(f$ as string, startOfImage as long, endOfImage as long)
    DIM File AS QFileStream
    dim wHshift as short
    dim wVshift as short
    dim wWidth as short
    dim wHeight as short
    dim ptrWork as long
    dim wb as byte
    dim iLength as word
    dim iData as byte
    dim iPixel as byte
    dim a as word
    dim b as word
    dim formXoffset as word
    dim formYoffset as word
    dim pixSize as word
    
    File.Open(f$, fmOpenRead)
    file.position = startOfImage     

    listbox1.additems "  image offset " & right$("00000000" & hex$(startOfImage),8) & "    "
     
    file.read(wHshift)
    listbox1.additems "    horizontal shift " & right$("00000000" & hex$(wHshift),4) & right$("      " & str$(wHshift),5)

    file.read(wVshift)
    listbox1.additems "      vertical shift " & right$("00000000" & hex$(wVshift),4) & right$("      " & str$(wVshift),5)

    file.read(wWidth)
    listbox1.additems "               width " & right$("00000000" & hex$(wWidth),4) & right$("      " & str$(wWidth),5)

    file.read(wHeight)
    listbox1.additems "              height " & right$("00000000" & hex$(wHeight),4) & right$("      " & str$(wHeight),5)

    file.read(wb)
    listbox1.additems "              ??????   " & right$("00000000" & hex$(wb),2) & right$("      " & str$(wb),5)

    listbox1.visible = true
    
    y = 1
' work on image line
    ptrWork = file.position
    while ptrWork < endOfImage
    h$ = ""
    x = 1
        file.read(iLength)
        h$ = h$ & right$("00000000" & hex$(iLength),4) & "  " 
        listbox1.additems " line data " & str$(iLength)
        ptrWork = file.position + iLength 
        l$ = ""
        
        if ptrWork > endOfImage then
            listbox1.additems " bad stuff "
            file.position = startOfImage
            h$ = ""
            while file.position < endOfImage 
                file.read(iData)
                h$ = h$ & right$("00000000" & hex$(iData),2) & " " 
                if len(h$) > 70 then
                    listbox1.additems h$
                    h$ = ""
                end if
            wend    
            listbox1.additems h$
            listbox1.additems "    ------------    "
            listbox1.additems ""
            exit sub
        end if
        
        ' iLength has number of bytes in line
        ' positioned at line data
        while file.position < ptrWork
            ' image data
'    listbox1.additems " pixel data "
            file.read(iData)
            h$ = h$ & right$("00000000" & hex$(iData),2) & " " 
            if wb = 162 then
            ' normal ...
                if iData > &HC0 then
                ' empty pixels for iData - 192
                    for b = 1 to iData - 192
                        l$ = l$ & "_"
                        x = x + 1
                    next b
                    h$ = h$ & ". " 
                elseif iData > &H80 then
                ' repeated data for iData - 128
                    file.read(iPixel)
                    h$ = h$ & right$("00000000" & hex$(iPixel),2) & " " 
                    for b = 1 to iData - 128
                        l$ = l$ & "R"
                        x = x + 1
                    next b
                    h$ = h$ & ". " 
                elseif iData > &H40 then
                ' soft drawn
                    for b = 1 to iData - 64
                        file.read(iPixel)
                        h$ = h$ & right$("00000000" & hex$(iPixel),2) & " " 
                        l$ = l$ & "S"
                        x = x + 1
                    next b
                    h$ = h$ & ". " 
                else
                ' normal
                    for b = 1 to iData 
                        file.read(iPixel)
                        h$ = h$ & right$("00000000" & hex$(iPixel),2) & " " 
                        l$ = l$ & "N"
                        x = x + 1
                    next b
                    h$ = h$ & ". " 
                end if
            elseif wb = 163 then
' shadows ??? ...
                if iData > &H80 then
                ' empty pixels for iData - 192
                    for b = 1 to iData - 128
                        l$ = l$ & "_"
                        x = x + 1
                    next b
                    h$ = h$ & ". " 
                else
                ' normal shadow
                    for b = 1 to iData 
                        l$ = l$ & "S"
                        x = x + 1
                    next b
                    h$ = h$ & ". " 
                end if
            else
            end if
        wend    
        listbox1.additems h$
    y = y + 1
    wend
    
    listbox1.additems ""     
    file.close
    
end sub


'--------- Subroutines for documentation---------

sub docMission
'    listbox1.additems origDir$ & "\doc_ssf.exe " & chr$(34) & edit1.text & chr$(34)
'
'    originally called other program ...
'    run origDir$ & "\SuStF_doc.exe " & chr$(34) & edit1.text & chr$(34)
'
    dim mp as string
    glbWhatInList = ""
    listbox1.clear
    listbox1.additems ""
    listbox1.additems edit1.text
    listbox1.additems ""
    listbox1.additems date$ & " " & time$
    listbox1.additems ""
    mp = edit1.text 
    call getBriefing (mp)
    call getplayers (mp)
    call getgroups (mp)
    call getsupport (mp)
    call getmapunits (mp)
    call getphrases (mp)
    call getScripts (mp)
end sub


sub explain
    listbox1.additems ""
    listbox1.additems form.caption
    listbox1.additems "written in rapid-q basic language."
    listbox1.additems ""
    listbox1.additems ""
    listbox1.additems "check to see that the boxes above point to"
    listbox1.additems "your Sudden Strike installation. "
    listbox1.additems "the left box should be where SuSt is installed. "
    listbox1.additems "the right box points to the map / mission folder. "
    listbox1.additems ""    
    listbox1.additems "adjust the right hand box to the map and mission you "
    listbox1.additems "want to create documentation for. "
    listbox1.additems "make sure to leave the \ characters where thry are.  "
    listbox1.additems "there is no error checking on folder names and such (yet)"
    listbox1.additems ""
    listbox1.additems "once you have the folder pointing where you want it"
    listbox1.additems "press the 'run it' button."
    listbox1.additems ""
    listbox1.additems "some of the editor created files will be read and the"
    listbox1.additems "information will be displayed."
    listbox1.additems ""
    listbox1.additems "this program can parse and display most of the editor"
    listbox1.additems "conditions and commands."
    listbox1.additems ""
    listbox1.additems "if doc_ssf doesn't recognise a command token it will"
    listbox1.additems "be displayed following ?????-- to indicate a problem."
    listbox1.additems ""
    listbox1.additems "there is a button to allow the information to be written"
    listbox1.additems "to a text (d_doc.txt) file in the mis.??? folder.  "
    listbox1.additems ""
    listbox1.additems "there is another button to copy selected lines to the"
    listbox1.additems "clipboard.  drag across a number of lines to select a block"
    listbox1.additems "of text.  use Ctrl button to select mutiple blocks of text."
    listbox1.additems ""
    listbox1.additems ""
    listbox1.additems ""
end sub

sub getScripts (mPath as string)
   '-- Enter your code here
     DIM File AS QFileStream
'     f$ = edit1.text & edit2.text & "scripts2"
     f$ = mPath & "scripts2"
     File.Open(f$, fmOpenRead)
     listbox1.additems "-- SCRIPTS2 file --"
     listbox1.additems ""
     cond! = 0
     xp$ = "                                       "
     while not file.eof
        i$ = file.readline
        
        if left$(i$,6) = "script" then
            i$ = mid$(i$,9)
            a! = instr(1, i$, " size ")
            i$ = left$(i$, a! - 2)
            listbox1.additems "SCRIPT NAME:"
            listbox1.additems i$
            listbox1.additems ""
            listbox1.additems "CONDITION:"
            cond! = 1
            'p$ = "condition: "
        else 
           select case i$
' things that can be skipped ...
               case "!", "", "$te", "$sp_5", "$mo", "$spc", "$sp_7"
               case "$sp_8", "$sp_9", "$sp_k", "$sp_a", "$sp_b", "$sp_c"
               case "$sp_6"
' conditions ...
' mission start
               case "$mist"
                   p$ = p$ & "mission start"
               case "$tms"
                   p$ = p$ & "time from start of mission is "

               case "$cd"
                   p$ = p$ & "countdown timer is "
               case "$oid"
                   p$ = p$ & "object "
               case "$oid1"
                   p$ = p$ & " is dead"
               case "$gwata"
                   p$ = p$ & "group "
               case "$gwata1"
                   p$ = p$ & " was attacked "
               case "$gwata2"
                   p$ = p$ & " ago "
               case "$aigb"
                   p$ = p$ & "AI_BEHAVIOUR of group "
               case "$aiz1", "$aiz2"
                   p$ = p$ & "AI_LOC" & right$(i$,1) & " of group "
               case "$aig1", "$aig2"
                   p$ = p$ & "AI_GRP" & right$(i$,1) & " of group "
               case "$aigb1", "$aiz_1", "$aiz_2", "$aig_1", "$aig_2"
                   p$ = p$ & " is "
               case "$mstl"
                   p$ = p$ & "move screen to location "
' units of group in location
               case "$ugl", "$ugl%", "$upl", "$upl%", "$ug%u", "$ug", "$up%", "$up"
                   p$ = p$ & "there is "
               case "$umx0"
                   p$ = p$ & "units of group "
               case "$umx4", "$ug%u1", "$ug1"
                   p$ = p$ & "units in group "
               case "$umx1"
                   p$ = p$ & "per cent of units of group "
               case "$umx2", "$up%u1", "$up%u2", "$up1"
                   p$ = p$ & "units of player "
               case "$umx3"
                   p$ = p$ & "per cent of units of player "
               case "$ugl1", "$upl1"
                   p$ = p$ & "in location "
               case "$ugut1"
                   p$ = p$ & "% of "
               case "$&"
                   listbox1.additems p$
                   p$ = ""
                   listbox1.additems "AND"
'                   p$ = p$ & " AND "
               case "$|"
                   listbox1.additems p$
                   p$ = ""
                   listbox1.additems "OR"
'                   p$ = p$ & " OR "
' active number follows
               case "$UMSK"
               ' object format 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q! = val(q$)
                   p1$ = ""
                   if q! AND 1 then 
                       p1$ = p1$ & "active"
                   end if
                   if q! AND 2 then 
                       if p1$ <> "" then p1$ = p1$ & "+"
                       p1$ = p1$ & "captured"
                   end if
                   if q! AND 4 then 
                       if p1$ <> "" then p1$ = p1$ & "+"
                       p1$ = p1$ & "destroyed"
                   end if
                   if q! AND 8 then 
                       if p1$ <> "" then p1$ = p1$ & "+"
                       p1$ = p1$ & "on the way"
                   end if
                   p$ = p$ & p1$ & " "
                   'p$ = p$ & " (" & str$(q!) & ") "
' actions ...
               case "$sres", "$sres1", "$sres2", "$sres3"
                   if right$(i$,1) = "s" then
                       p$ = p$ & "DEFINE initial forces: Russian- "
                   elseif right$(i$,1) = "1" then
                       p$ = p$ & ", German- "
                   elseif right$(i$,1) = "2" then
                       p$ = p$ & ", Allies- "
                   elseif right$(i$,1) = "3" then
                       p$ = p$ & ", delay "
                   end if

               case "$fres", "$fres0", "$fres1", "$fres2", "$fres3"
                   if right$(i$,1) = "s" then
                       p$ = p$ & "DEFINE reinforcements for zeppelin(s) "
                   elseif right$(i$,1) = "0" then
                       p$ = p$ & ": Russians- "
                   elseif right$(i$,1) = "1" then
                       p$ = p$ & ", German- "
                   elseif right$(i$,1) = "2" then
                       p$ = p$ & ", Allies- "
                   elseif right$(i$,1) = "3" then
                       p$ = p$ & ", delay "
                   end if

               case "$pff"
                   p$ = p$ & "DEFINE air support for zeppelin(s) "

               case "$fpff"
                   p$ = p$ & "flights of planes for flags "
               case "$fpff1 "
                   p$ = p$ & "for "

               case "$mff"
                   p$ = p$ & "DEFINE additional messages for zeppelin(s) "

' zeppein number follows
               case "$Fmask"
               ' location format 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   a# = 1
                   q# = val(q$)
                   q$ = ""
                   for a! = 0 to 29
                       if q# and a# then q$ = q$ & "," & str$(a!)
                       a# = a# * 2
                   next a!
'                   q# = val(q$) - 1
'                   q$ = str$(q#)
                   p$ = p$ & mid$(q$,2) & " "

               case "$sp", "$sppo"
                   p$ = p$ & "say phrase "
               case "$sppo1"
                   p$ = p$ & "showing pointer to object "
               case "$etc"
                   p$ = p$ & "remove this trigger"
               case "$stpt"
                   p$ = p$ & "stop "
               case "$strt", "$sppa"
                   p$ = p$ & "start "
               case "$app", "$afp"
                   p$ = p$ & "give to player "
               case "$afp1"
                   p$ = p$ & "flights of "
' timer number
               case "$Tr"
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   p$ = p$ & "timer #" & q$ & " "
' time format follows               
               case "$T"
               ' time format 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q# = val(q$)
                   h! = q# \ 3600
                   q# = q# - (h! * 3600)
                   m! = q# \ 60
                   s! = q# - (m! * 60)
                   p$ = p$ & right$("00" & str$(h!),2) & ":" & right$("00" & str$(m!),2) & ":" & right$("00" & str$(s!), 2) & " " '" (" & q$ & " seconds) "
' group noumber follows
               case "$G", "$Grp"
               ' group format 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q! = val(q$)
'                   c! = q! \ 10
'                   r! = q! - (c! * 10)
'                   p$ = p$ & chr$( asc("A") + c!) & str$(r!)  & " "
                   q$ = groupId(q!)
                   p$ = p$ & q$ & " "
' location number follows
               case "$L"
               ' location format 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q# = val(q$)
                   
                   p$ = p$ & "#" & q$ & " "
' number follows
               case "$N1", "$I"
               ' location format 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   if q$ = "" then q$ = "0"
                   q# = val(q$)
                   p$ = p$ & q$ & " "
' object number follows
               case "$Obj"
               ' object format 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q# = val(q$)
                   
                   p$ = p$ & "#" & q$ & " "
' mission end value follows
               case "$F"
                   i$ = file.readline
                   select case i$
                       case "#"
                          p$ = p$ & "tie "
                       case "#1"
                          p$ = p$ & "victory "
                       case "#2"
                          p$ = p$ & "defeat "
                   end select
' player number follows
               case "$P", "$Plr"
                   i$ = file.readline
                   select case i$
                       case "#"
'                          p$ = p$ & " Player "
                          p! = 0
'                          p$ = p$ & " " & pName$(p!) & " "
                          p$ = p$ & pn0$ & " "
                       case "#1"
'                          p$ = p$ & " Enemy "
                          p! = 1
'                          p$ = p$ & " " & pName$(p!) & " "
                          p$ = p$ & pn1$ & " "
                       case "#2"
'                          p$ = p$ & " Ally "
                          p! = 2
'                          p$ = p$ & " " & pName$(p!) & " "
                          p$ = p$ & pn2$ & " "
                       case "#3"
'                          p$ = p$ & " Neutral "
                          p! = 3
'                          p$ = p$ & " " & pName$(p!) & " "
                          p$ = p$ & pn3$ & " "
                   end select
' math functions
               case "$Math"
                   i$ = file.readline
                   select case i$
                       case "#"
                          p$ = p$ & "increase by "
                       case "#1"
                          p$ = p$ & "decrease by "
                   end select
' flag noumber follows
               case "$flg"
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q! = val(q$)
                   p$ = p$ & chr$( asc("A") + q!) & " " 
' reserve group noumber follows
               case "$resv"
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q! = val(q$)
                   p$ = p$ & reinf$(q!) & " "
                   'p$ = p$ & " (res grp " & str$(q!) & ")"
' phrase
               case "$phrs"
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q! = val(q$)
                   p$ = p$ & "'" & phrs$(q!) & "' "
                   'p$ = p$ & " (res grp " & str$(q!) & ")"
' comparison operator follows
               case "$CABE", "$CAB"
                   i$ = file.readline
                   select case i$
                       case "#"
                          p$ = p$ & "exactly "
                       case "#1"
                          p$ = p$ & "more than "
                       case "#2"
                          p$ = p$ & "less than "
                   end select
' planes follows
               case "$PT"
                   i$ = file.readline
                   select case i$
                       case "#"
                          p$ = p$ & "bombers "
                       case "#1"
                          p$ = p$ & "spy planes "
                       case "#2"
                          p$ = p$ & "transports "
                       case "#3"
                          p$ = p$ & "cargo transports "
                   end select
               case "$sppl", "$spto"
                   p$ = p$ & "send "
               case "$sppl1", "$spto1", "$sppa1"
                   p$ = p$ & "of player "
               case "$sppl2"
                   p$ = p$ & "to location "
               case "$spto2"
                   p$ = p$ & "to object "
               case "$sat"
                   p$ = p$ & "start plane route "
               case "$arpo"
                   p$ = p$ & "add route pointer over object "
               case "$sppa2"
                   p$ = p$ & "using defined avia route "
               case "$aspo"
                   p$ = p$ & "add strike pointer over object "
               case "$snm"
                   p$ = p$ & "set next mission to "
               case "$dgp"
                   p$ = p$ & "transfer group "
               case "$dgp1"
                   p$ = p$ & "to player "
               case "$strt1"
                   p$ = p$ & "setting it to "
               case "$fvkgz"
                   p$ = p$ & "launch rockets using RL of group "
               case "$fvkgz1"
                   p$ = p$ & "to location "
               case "$fvkgo"
                   p$ = p$ & "launch rockets using RL of group "
               case "$fvkgo1"
                   p$ = p$ & "to object "
               case "$scd"
                   p$ = p$ & "start countdown from "
               case "$tm"
                   p$ = p$ & "end mission as "
               case "$ru"
                   p$ = p$ & "resurrect units of group "
               case "$ru1"
                   p$ = p$ & "via anchor "
               case "$ru2"
                   p$ = p$ & "to location "
               case "$ru3"
                   p$ = p$ & "with delay "
               case "$ru4"
                   p$ = left$(p$, len(p$) - 1)
                   p$ = p$ & ", setting health to "
               case "$ru5"
                   p$ = left$(p$, len(p$) - 1)
                   p$ = p$ & ", ammo to "
               case "$ru6"
                   p$ = left$(p$, len(p$) - 1)
                   p$ = p$ & ", experience to "
               case "$sgb"
                   p$ = p$ & "SET AI_BEHAVOUR of group "
               case "$sgl1", "$sgl2"
                   p$ = p$ & "SET AI_LOC" & right$(i$,1) & " of group "
               case "$sgg1", "$sgg2"
                   p$ = p$ & "SET AI_GRP" & right$(i$,1) & " of group "
               case "$sgb1", "$sgl11", "$sgl21", "$sgg11", "$sgg21"
                   p$ = p$ & "to "
               case "$AI"
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
'                   listbox1.additems i$ & " - " & q$
                   q# = val(q$)
'                   r! = q! AND 7
                   r! = q# AND 15
                   q# = q# - r!
                   if r! = 0 then
                       p$ = p$ & "None "     
                       listbox1.additems p$
                       p$ = ""
                   elseif r! = 1 then
                       p$ = p$ & "Reconnassance "     
                       listbox1.additems p$
                       p$ = ""
                   elseif r! = 2 then
                       p$ = p$ & "Infantry - Guard location "
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                       if (q# AND 2048) = 2048 then 
                           listbox1.additems xp$ & "AT guns - Do not occupy, free occupied "
                           q# = q# - 2048
                       end if
                       if (q# AND 4096) = 4096 then 
                           listbox1.additems xp$ & "AT guns - Move to location only if our units are there "
                           q# = q# - 4096
                       end if
                       if (q# AND 8192) = 8192 then 
                           listbox1.additems xp$ & "AT guns - Move to location only no enemy units are there "
                           q# = q# - 8192
                       end if
                       if (q# AND 16384) = 16384 then 
                           listbox1.additems xp$ & "AT guns - Do not move to new location (anyway) "
                           q# = q# - 16384
                       end if
                       if (q# AND 32768) = 32768 then 
                           listbox1.additems xp$ & "AT guns - Do not pull to new location (without a truck) "
                           q# = q# - 32768
                       end if
                       if (q# AND 65536) = 65536 then 
                           listbox1.additems xp$ & "AT guns - Do not abandon "
                           q# = q# - 65536
                       end if
                       if (q# AND 131072) = 131072 then 
                           listbox1.additems xp$ & "Howitzers - Do not occupy, free occupied "
                           q# = q# - 131072
                       end if
                       if (q# AND 262144) = 262144 then 
                           listbox1.additems xp$ & "Howitzers - Move to location only if our units are there "
                           q# = q# - 262144
                       end if
                       if (q# AND 524288) = 524288 then 
                           listbox1.additems xp$ & "Howitzers - Move to location only if no enemy units are there "
                           q# = q# - 524288
                       end if
                       if (q# AND 1048576) = 1048576 then 
                           listbox1.additems xp$ & "Howitzers - Do no move to new location (anyway) "
                           q# = q# - 1048576
                       end if
                       if (q# AND 2097152) = 2097152 then 
                           listbox1.additems xp$ & "Howitzers - Do no pull to new location (without a truck) "
                           q# = q# - 2097152
                       end if
                       if (q# AND 4194304) = 4194304 then 
                           listbox1.additems xp$ & "Howitzers - Do not abandon "
                           q# = q# - 4194304
                       end if
                       if (q# AND 67108864) = 67108864 then 
                           listbox1.additems xp$ & "Howitzers - Do not shoot "
                           q# = q# - 67108864
                       end if
                       if (q# AND 8388608) = 8388608 then 
                           listbox1.additems xp$ & "Buildings - Do not occupy - free occupied "
                           q# = q# - 8388608
                       end if
                       if (q# AND 16777216) = 16777216 then 
                           listbox1.additems xp$ & "Buildings - Ambush "
                           q# = q# - 16777216
                       end if
                       if (q# AND 33554432) = 33554432 then 
                           listbox1.additems xp$ & "Buildings - Hide to last ditch "
                           q# = q# - 33554432
                       end if
                   elseif r! = 3 then
                       p$ = p$ & "Infantry - Track group "     
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 256) = 256 then 
                           listbox1.additems xp$ & "Randomly change tracked unit "
                           q# = q# - 256
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                       if (q# AND 2048) = 2048 then 
                           listbox1.additems xp$ & "AT guns - Do not occupy, free occupied "
                           q# = q# - 2048
                       end if
                       if (q# AND 8388608) = 8388608 then 
                           listbox1.additems xp$ & "Buildings - Do not occupy - free occupied "
                           q# = q# - 8388608
                       end if
                   elseif r! = 4 then
                       p$ = p$ & "Infantry - Howitzer crew " 
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                       if (q# AND 2048) = 2048 then 
                           listbox1.additems xp$ & "AT guns - Do not occupy, free occupied "
                           q# = q# - 2048
                       end if
                       if (q# AND 4096) = 4096 then 
                           listbox1.additems xp$ & "AT guns - Move to location only if our units are there "
                           q# = q# - 4096
                       end if
                       if (q# AND 8192) = 8192 then 
                           listbox1.additems xp$ & "AT guns - Move to location only no enemy units are there "
                           q# = q# - 8192
                       end if
                       if (q# AND 16384) = 16384 then 
                           listbox1.additems xp$ & "AT guns - Do not move to new location (anyway) "
                           q# = q# - 16384
                       end if
                       if (q# AND 32768) = 32768 then 
                           listbox1.additems xp$ & "AT guns - Do not pull to new location (without a truck) "
                           q# = q# - 32768
                       end if
                       if (q# AND 65536) = 65536 then 
                           listbox1.additems xp$ & "AT guns - Do not abandon "
                           q# = q# - 65536
                       end if
                       if (q# AND 131072) = 131072 then 
                           listbox1.additems xp$ & "Howitzers - Do not occupy, free occupied "
                           q# = q# - 131072
                       end if
                       if (q# AND 262144) = 262144 then 
                           listbox1.additems xp$ & "Howitzers - Move to location only if our units are there "
                           q# = q# - 262144
                       end if
                       if (q# AND 524288) = 524288 then 
                           listbox1.additems xp$ & "Howitzers - Move to location only if no enemy units are there "
                           q# = q# - 524288
                       end if
                       if (q# AND 1048576) = 1048576 then 
                           listbox1.additems xp$ & "Howitzers - Do no move to new location (anyway) "
                           q# = q# - 1048576
                       end if
                       if (q# AND 2097152) = 2097152 then 
                           listbox1.additems xp$ & "Howitzers - Do no pull to new location (without a truck) "
                           q# = q# - 2097152
                       end if
                       if (q# AND 4194304) = 4194304 then 
                           listbox1.additems xp$ & "Howitzers - Do not abandon "
                           q# = q# - 4194304
                       end if
                       if (q# AND 67108864) = 67108864 then 
                           listbox1.additems xp$ & "Howitzers - Do not shoot "
                           q# = q# - 67108864
                       end if
                       if (q# AND 8388608) = 8388608 then 
                           listbox1.additems xp$ & "Buildings - Do not occupy - free occupied "
                           q# = q# - 8388608
                       end if
                       if (q# AND 16777216) = 16777216 then 
                           listbox1.additems xp$ & "Buildings - Ambush "
                           q# = q# - 16777216
                       end if
                       if (q# AND 33554432) = 33554432 then 
                           listbox1.additems xp$ & "Buildings - Hide to last ditch "
                           q# = q# - 33554432
                       end if
                   elseif r! = 5 then
                       p$ = p$ & "Tanks - Guard location " 
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                   elseif r! = 6 then
                       p$ = p$ & "Tanks - Track group " 
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 256) = 256 then 
                           listbox1.additems xp$ & "Randomly change tracked unit "
                           q# = q# - 256
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                   elseif r! = 7 then
                       p$ = p$ & "Transport - Assist " 
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 256) = 256 then 
                           listbox1.additems xp$ & "Randomly change tracked unit "
                           q# = q# - 256
                       end if
                       if (q# AND 1024) = 1024 then 
                           listbox1.additems xp$ & "Go to location only if there is nobody to track "
                           q# = q# - 1024
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                       if (q# AND 512) = 512 then 
                           listbox1.additems xp$ & "Assist specified groups only "
                           q# = q# - 512
                       end if
                   elseif r! = 8 then
                       p$ = p$ & "Transport - Go to location " 
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                   elseif r! = 9 then
                       p$ = p$ & "Supply trucks - Repair " 
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                       if (q# AND 128) = 128 then 
                           listbox1.additems xp$ & "Repair objects "
                           q# = q# - 128
                       end if
                       if (q# AND 1024) = 1024 then 
                           listbox1.additems xp$ & "Repair only within location "
                           q# = q# - 1024
                       end if
                       if (q# AND 67108864) = 67108864 then 
                           listbox1.additems xp$ & "Build pontoon bridges "
                           q# = q# - 67108864
                       end if
                   elseif r! = 10 then
                       p$ = p$ & "Rocket launchers - Go to location " 
                       listbox1.additems p$
                       p$ = ""
                       if (q# AND 16) = 16 then 
                           listbox1.additems xp$ & "Move chaotically within location "
                           q# = q# - 16
                       end if
                       if (q# AND 32) = 32 then 
                           listbox1.additems xp$ & "Go to location only if our units are there "
                           q# = q# - 32
                       end if
                       if (q# AND 64) = 64 then 
                           listbox1.additems xp$ & "Go to location only if no enemy units are there "
                           q# = q# - 64
                       end if
                       if (q# AND 67108864) = 67108864 then 
                           listbox1.additems xp$ & "Do not shoot automatically "
                           q# = q# - 67108864
                       end if
                   end if
               ' show value ...
                   if q# <> 0 then p$ = p$ & "                  (" & str$(q#) & ") "
               case "$strt1"
                   p$ = p$ & "setting it to "
               case "$vic"
                   p$ = p$ & "value in cell "
               case "$lccv"
                   p$ = p$ & "let cell "
               case "$lccv1"
                   p$ = p$ & "contain "
               case "$mission"
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   q# = val(q$)
                   if q# = 33280 then
                       p$ = p$ & "force replay "
                   elseif q# = 33024 then
                       p$ = p$ & "campaign won "
                   elseif q# = 32768 then
                       p$ = p$ & "campaign failed "
                   else
                       p! = q# \ 256
                       q! = q# - (p! * 256)
                       p$ = p$ & str$(p!) & ":" & str$(q!)
                   end if
               case "$Rvar"
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   if q$ = "" then q$ = "0"
                   q# = val(q$)
                   if q# > 2147483391 then
                       p$ = p$ & "C_" & str$(q# - 2147483392) & " "
                   else
                       p$ = p$ & "number " & q$ & " "
                   end if
               case "$Lvar"
               ' cell numbers 
                   i$ = file.readline
                   q$ = ""
                   for a! = 2 to len(i$)
                       q$ = mid$(i$,a!,1) & q$
                   next a!
                   'listbox1.additems i$ & " - " & q$
                   if q$ = "" then q$ = "0"
                   q# = val(q$)
                   if q# > 2147483391 then
                       p$ = p$ & "C_" & str$(q# - 2147483392) & " "
                   else
                       p$ = p$ & "number " & q$ & " "
                   end if
                   
               case "$srfs"
                   p$ = p$ & "send to player "
               case "$srfs0"
                   p$ = p$ & "reinforcement of type "
               case "$srfs1"
                   p$ = p$ & "via anchor "
               case "$srfs2"
                   p$ = p$ & "to location "
               case "$srfs3"
                   p$ = p$ & "with delay "
               case "$END"
                   listbox1.additems p$, ""
                   if cond! = 1 then
                       listbox1.additems "ACTION:"
                       cond! = 0
                   end if
                   p$ = ""
               case "$\\n"
                   if p$ <> "" then listbox1.additems p$
                   p$ = ""
               case else
                   listbox1.additems p$, "?????--'" & i$ & "'"
                   p$ = ""
            end select
        end if
     wend
     file.close
'     button1.visible = false
'     button2.visible = true
'     button3.visible = true
'     button4.visible = true
'     edit3.visible = true
'     button5.visible = true
END SUB

sub getSupport (mPath as string)
     DIM File AS QFileStream
     p! = 0
     q! = 0
     listbox1.additems "-- SUPPORT file --"
' get gates ...
'     f$ = edit1.text & edit2.text & "support"
     f$ = mPath & "support"
     File.Open(f$, fmOpenRead)
     listbox1.additems "-- GATES --"
     while not file.eof
        i$ = file.readline
        p$ = ""
        if left$(i$,4) = "flag" then
            p$ = p$ & chr$( asc("A") + p!)
            p! = p! + 1
            if i$ <> "flag -1,-1,0,-1,-1" then listbox1.additems p$ & " " & i$
        end if
     wend
     file.close
' get reinforcement groups ...
'     f$ = edit1.text & edit2.text & "support"
     f$ = mPath & "support"
     File.Open(f$, fmOpenRead)
     listbox1.additems ""
     listbox1.additems "-- REINFORCEMENTS --"
     while not file.eof
        i$ = file.readline
        p$ = ""
        if left$(i$,7) = "support" then
            p$ = p$ & "(" & str$(q!) & ")"
            j$ = mid$(i$,10)
            j$ = left$(j$,len(j$) - 1)
            reinf$(q!) = j$
            q! = q! + 1
            if j$ <> "" then listbox1.additems p$ & " " & j$
        end if
'        if left$(i$,4) = " ID=" then
        if instr(i$,"ID=") <> 0 then
           listbox1.additems " " & i$
        end if
     wend
     file.close
     listbox1.additems ""
     listbox1.additems ""
end sub

sub getMapUnits (mPath as string)
     DIM File AS QFileStream
     p! = 0
     q! = 0
     listbox1.additems "-- MAPUNITS file --"
' get units placed on map ...
'     f$ = edit1.text & edit2.text & "mapunits"
     f$ = mPath & "mapunits"
     File.Open(f$, fmOpenRead)
     listbox1.additems ""
     while not file.eof
        i$ = file.readline
        p$ = ""
        i$ = ltrim$(i$)
        if left$(i$,3) = "ID=" then
           if instr(i$,"U=") = 0 then
               listbox1.additems "   " & i$
           else
               listbox1.additems "  " & i$
           end if
        end if
     wend
     file.close
     listbox1.additems ""
     listbox1.additems ""
end sub

sub getBriefing (mPath as string)
     DIM File AS QFileStream
     p! = 0
     q! = 0
     listbox1.additems "-- MISDESC file --"
' get reinforcement groups ...
'     f$ = edit1.text & edit2.text & "misdesc"
     f$ = mPath & "misdesc"
     File.Open(f$, fmOpenRead)
     listbox1.additems ""
     while not file.eof
        i$ = file.readline
        listbox1.additems i$
     wend
     file.close
     listbox1.additems ""
     listbox1.additems ""
end sub

sub getPhrases (mPath as string)
     DIM File AS QFileStream
     p! = 0
     q! = 0
     listbox1.additems "-- PHRASES file --"
'     f$ = edit1.text & edit2.text & "phrases"
     f$ = mPath & "phrases"
     File.Open(f$, fmOpenRead)
     while not file.eof
        i$ = file.readstr(320)
        o$ = ""
        for a! = 1 to len(i$)
            if mid$(i$,a!,1) = chr$(0) then 
                if first! = 1 then o$ = o$ & " "
            else
                o$ = o$ & mid$(i$,a!,1)
                first! = 0
            end if
        next a!
        i$ = rtrim$(ltrim$(o$))
'        i$ = left$(i$, instr(i$, chr$(0)) - 1)
        if i$ <> "" then listbox1.additems "(" & str$(p!) & ") " & i$ 
        phrs$(p!) = i$
        p! = p! + 1
     wend
     file.close
     listbox1.additems ""
     listbox1.additems ""
end sub

sub getGroups (mPath as string)
     DIM File AS QFileStream
     dim l1 as string
     dim l2 as string
     dim l3 as string
     dim l4 as string
     dim t2 as string
     dim t3 as string
     dim t4 as string
     t2 = " ai type=" & chr$(34) & "ai_none" & chr$(34) & " group1=0 group2=0 zone1=0 zone2=0"
     t3 = "  aiflags="
     t4 = " reserv auto=0 delay=0 min=0 force=0 atime=0 flag=0 zone=0 hp=100 ammo=100 expa=0"
     p! = 0
     q! = 0
     listbox1.additems "-- GROUPS file --"
' get reinforcement groups ...
'     f$ = edit1.text & edit2.text & "groups"
     f$ = mPath & "groups"
     File.Open(f$, fmOpenRead)
     listbox1.additems ""
     while not file.eof
        l1 = file.readline
        l2 = file.readline
        l3 = file.readline
        l4 = file.readline
        if l2 <> t2 or l3 <> t3 or l4 <> t4 then
            g$ = lastpart(l1)
            g! = val(g$)
            g$ = groupId(g!)
            listbox1.additems "Group " & g$
            listbox1.additems l2
            listbox1.additems l3
            listbox1.additems l4
        end if
     wend
     file.close
     listbox1.additems ""
     listbox1.additems ""
end sub

sub getPlayers (mPath as string)
     DIM File AS QFileStream
     p! = 0
     q! = 0
     listbox1.additems "-- PLAYERS file --"
' get reinforcement groups ...
'     f$ = edit1.text & edit2.text & "players"
     f$ = mPath & "players"
     File.Open(f$, fmOpenRead)
     listbox1.additems ""
     o$ = ""
     while not file.eof
        i$ = file.readline
        if left$(i$,7) = "Player " then
            if o$ <> "" then listbox1.additems o$
            p! = val(mid$(i$,8,1))
            listbox1.additems ""
            o$ = i$
        end if
        if left$(i$,6) = " name=" then
            w$ = mid$(i$,8)
            w$ = left$(w$, len(w$)-1)
            pName$(p!) = w$
            o$ = o$ & "   name: " 
            o$ = o$ & "(" & str$(p!) & ") " 
            o$ = o$ & pName$(p!) 
            listbox1.additems o$
            o$ = ""
        end if
        if left$(i$,6) = " team=" then
            q! = val(mid$(i$,7,1))
            select case q!
                case 0
                  p$ = "Player"
                case 1
                  p$ = "Enemy"
                case 2
                  p$ = "Ally"
                case 3
                  p$ = "Neutral"
            end select
            o$ = o$ & "           team: " & p$ 
            listbox1.additems o$
            o$ = ""
        end if
        if left$(i$,8) = " nation=" then
            q! = val(mid$(i$,9,1))
            select case q!
                case 0
                  p$ = "Russians"
                case 1
                  p$ = "Germans"
                case 2
                  p$ = "Allies"
            end select
            o$ = o$ & "         nation: " & p$ 
            listbox1.additems o$
            o$ = ""
        end if
        if left$(i$,7) = " color=" then
'            o$ = o$ & " " & i$ 
        end if
        if i$ = " bomb" then
            if o$ <> "" then listbox1.additems o$
            o$ = "         bomber:" 
        end if
        if i$ = " spy" then
            if o$ <> "" then listbox1.additems o$
            o$ = "      spy plane:" 
        end if
        if i$ = " transport" then
            if o$ <> "" then listbox1.additems o$
            o$ = "      transport:" 
        end if
        if i$ = " boxer" then
            if o$ <> "" then listbox1.additems o$
            o$ = "          cargo:"
        end if
        if i$ = " descent 0" then
            if o$ <> "" then listbox1.additems o$
            o$ = " transport drop:"
        end if
        if i$ = " descent 1" then
            if o$ <> "" then listbox1.additems o$
            o$ = "     cargo drop:"
        end if
        if left$(i$,8) = "  group=" then
            o$ = o$ & " " & ltrim$(i$)
        end if
        if left$(i$,7) = "  expa=" then
            o$ = o$ & " " & ltrim$(i$)
        end if
        if left$(i$,5) = "  ID " then
            if o$ <> "" then listbox1.additems o$
            o$ = "                " & " " & ltrim$(i$)
        end if
        if left$(i$,9) = "  number " then
            o$ = o$ & & " " & ltrim$(i$)
            listbox1.additems o$
            o$ = ""
        end if
        if left$(i$,5) = "  ID=" then
            o$ = o$ & " " & ltrim$(i$)
        end if
        if left$(i$,9) = "  Number=" then
            o$ = o$ & " " & ltrim$(i$)
        end if
        if left$(i$,8) = "  Bombs=" then
            o$ = o$ & " " & ltrim$(i$)
        end if
        if left$(i$,9) = "  Reload=" then
            o$ = o$ & " " & ltrim$(i$)
        end if
        
'        listbox1.additems i$
     wend
     listbox1.additems o$
     file.close
     listbox1.additems ""
     listbox1.additems ""
     pn0$ = pName$(0)
     pn1$ = pName$(1)
     pn2$ = pName$(2)
     pn3$ = pName$(3)
end sub

function groupId (g as integer) as string
dim a as integer
dim b as integer
dim s as string
    a = g / 10
    b = g - (a * 10)
    s = ""
    s = chr$(asc("A") + a) & str$(b)
    groupId = s
end function

function unitDescription(t as string) as string
dim p$ as string
    unitDescription = p$
end function

