$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"

DECLARE SUB DrawCell (Col%, Row%, State%, Rect AS QRect, Sender AS QStringGrid)
DECLARE SUB SelectCell (Col%, Row%, CanSelect%, Sender AS QStringGrid)

DEFINT GridCheck(1 TO 10) = {-1,0,0,-1,0, 0,0,0,0,0}


CREATE Form AS QForm
    Caption = "Check Grid"
    CREATE Grid AS QStringGrid
        Align = alClient
        RowCount = 11
        AddOptions(goEditing, goThumbTracking)
        ColWidths(0) = 25
        ColWidths(4) = 25
        DefaultRowHeight = 20
        OnDrawCell = DrawCell
        OnSelectCell = SelectCell
    END CREATE
    Center
    ShowModal
END CREATE



SUB DrawCell (Col%, Row%, State%, Rect AS QRect, Sender AS QStringGrid)
  IF Col% = 4 AND Row% > 0 THEN
      Sender.Rectangle(Rect.Left+5, Rect.Top+Sender.DefaultRowHeight/2-5, Rect.Left+15, Rect.Top+Sender.DefaultRowHeight/2+5, 0)
      IF GridCheck(Row%) THEN
          Sender.Line(Rect.Left+10, Rect.Top+Sender.DefaultRowHeight/2+2, Rect.Left+16, Rect.Top+Sender.DefaultRowHeight/2-5, clRed)
          Sender.Line(Rect.Left+10, Rect.Top+Sender.DefaultRowHeight/2+1, Rect.Left+16, Rect.Top+Sender.DefaultRowHeight/2-6, clRed)
          Sender.Line(Rect.Left+10, Rect.Top+Sender.DefaultRowHeight/2+2, Rect.Left+7, Rect.Top+Sender.DefaultRowHeight/2-2, clRed)
          Sender.Line(Rect.Left+10, Rect.Top+Sender.DefaultRowHeight/2+1, Rect.Left+7, Rect.Top+Sender.DefaultRowHeight/2-3, clRed)
      END IF
  ELSE
      Sender.TextOut(Rect.Left+2, Rect.Top+2, Sender.Cell(Col%, Row%), 0, -1)
  END IF
END SUB


SUB SelectCell (Col%, Row%, CanSelect%, Sender AS QStringGrid)
  IF Col% = 4 THEN
      CanSelect% = 0
      GridCheck(Row%) = NOT GridCheck(Row%)
      Sender.Repaint
  END IF
END SUB

